"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deviceControl = {
    getEvents: { url: "device-control/events", method: "get" /* GET */ },
    countByFilters: { url: "private/device-control/filters-count", method: "get" /* GET */ },
    getInterfaces: { url: "private/device-control/interfaces", method: "get" /* GET */ },
    getUnscopedRules: { url: "/private/device-control/unscoped", method: "get" /* GET */ },
    getConfiguration: { url: "/device-control/configuration", method: "get" /* GET */ },
    updateConfiguration: { url: "/device-control/configuration", method: "put" /* PUT */ },
    copyRules: { url: "device-control/copy-rules", method: "post" /* POST */ },
    reorderRules: { url: "device-control/reorder", method: "put" /* PUT */ },
    exportRules: { url: "device-control/export", method: "get" /* GET */ },
    importRules: { url: "device-control/import", method: "post" /* POST */ },
    enableDisableRules: { url: "device-control/enable", method: "put" /* PUT */ },
    deleteRules: { url: 'device-control', method: "delete" /* DELETE */ },
    getDeviceRules: { url: "device-control", method: "get" /* GET */ },
    createDeviceRule: { url: "device-control", method: "post" /* POST */ },
    updateDeviceRule: { url: "device-control/{rule_id}", method: "put" /* PUT */ }
};
var deviceControlEndPointsTypes;
(function (deviceControlEndPointsTypes) {
    deviceControlEndPointsTypes["getEvents"] = "getEvents";
    deviceControlEndPointsTypes["countByFilters"] = "countByFilters";
    deviceControlEndPointsTypes["getInterfaces"] = "getInterfaces";
    deviceControlEndPointsTypes["getUnscopedRules"] = "getUnscopedRules";
    deviceControlEndPointsTypes["getConfiguration"] = "getConfiguration";
    deviceControlEndPointsTypes["updateConfiguration"] = "updateConfiguration";
    deviceControlEndPointsTypes["copyRules"] = "copyRules";
    deviceControlEndPointsTypes["reorderRules"] = "reorderRules";
    deviceControlEndPointsTypes["exportRules"] = "exportRules";
    deviceControlEndPointsTypes["importRules"] = "importRules";
    deviceControlEndPointsTypes["enableDisableRules"] = "enableDisableRules";
    deviceControlEndPointsTypes["deleteRules"] = "deleteRules";
    deviceControlEndPointsTypes["getDeviceRules"] = "getDeviceRules";
    deviceControlEndPointsTypes["createDeviceRule"] = "createDeviceRule";
    deviceControlEndPointsTypes["updateDeviceRule"] = "updateDeviceRule";
})(deviceControlEndPointsTypes = exports.deviceControlEndPointsTypes || (exports.deviceControlEndPointsTypes = {}));
exports.deviceControlEndPointsNames = deviceControlEndPointsTypes;
//# sourceMappingURL=device-control-endpoints.js.map