"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var threat_endpoints_1 = require("./threat-endpoints");
var authenticator_endpoints_1 = require("./authenticator-endpoints");
var sites_endpoints_1 = require("./sites-endpoints");
var groups_endpoints_1 = require("./groups-endpoints");
var agents_endpoints_1 = require("./agents-endpoints");
var update_endpoints_1 = require("./update-endpoints");
var reports_endpoints_1 = require("./reports-endpoints");
var policy_endpoints_1 = require("./policy-endpoints");
var system_endpoints_1 = require("./system-endpoints");
var exclusions_endpoints_1 = require("./exclusions-endpoints");
var config_override_1 = require("./config-override");
var activities_endpoints_1 = require("./activities-endpoints");
var settings_endpoints_1 = require("./settings-endpoints");
var agent_action_endpoints_1 = require("./agent-action-endpoints");
var filters_endpoints_1 = require("./filters-endpoints");
var forensics_endpoints_1 = require("./forensics-endpoints");
var deep_visibility_endpoints_1 = require("./deep-visibility-endpoints");
var deep_visibility_v2_1 = require("./deep-visibility-v2");
var commands_endpoints_1 = require("./commands-endpoints");
var users_endpoints_1 = require("./users-endpoints");
var hash_endpoints_1 = require("./hash-endpoints");
var accounts_endpoints_1 = require("./accounts-endpoints");
var applications_risk_endpoints_1 = require("./applications-risk-endpoints");
var firewall_controll_endpoints_1 = require("./firewall-controll-endpoints");
var device_control_endpoints_1 = require("./device-control-endpoints");
var tags_endpoints_1 = require("./tags-endpoints");
var custom_detection_rules_endpoints_1 = require("./custom-detection-rules-endpoints");
var rbac_endpoints_1 = require("./rbac-endpoints");
var cred_groups_endpoints_1 = require("./cred-groups-endpoints");
var cred_groups_details_endpoints_1 = require("./cred-groups-details-endpoints");
exports.endPoints = {
    users: users_endpoints_1.users,
    rbac: rbac_endpoints_1.rbac,
    commands: commands_endpoints_1.commands,
    settings: settings_endpoints_1.settings,
    forensics: forensics_endpoints_1.forensics,
    deepVisibility: deep_visibility_endpoints_1.deepVisibility,
    sites: sites_endpoints_1.sites,
    reports: reports_endpoints_1.reports,
    groups: groups_endpoints_1.groups,
    agents: agents_endpoints_1.agents,
    updates: update_endpoints_1.updates,
    policy: policy_endpoints_1.policy,
    exclusions: exclusions_endpoints_1.exclusions,
    system: system_endpoints_1.system,
    configOverride: config_override_1.configOverride,
    activities: activities_endpoints_1.activities,
    agentActions: agent_action_endpoints_1.agentActions,
    filters: filters_endpoints_1.filters,
    deepVisibilityV2: deep_visibility_v2_1.deepVisibilityV2,
    hash: hash_endpoints_1.hash,
    tags: tags_endpoints_1.tags,
    customDetectionRules: custom_detection_rules_endpoints_1.customDetectionRules,
    threats: threat_endpoints_1.threats,
    authenticator: authenticator_endpoints_1.authenticator,
    accounts: accounts_endpoints_1.accounts,
    applicationsRisk: applications_risk_endpoints_1.applicationsRisk,
    fireWallControl: firewall_controll_endpoints_1.fireWallControl,
    deviceControl: device_control_endpoints_1.deviceControl,
    credGroups: cred_groups_endpoints_1.credGroups,
    credGroupDetails: cred_groups_details_endpoints_1.credGroupDetails
};
exports.endPointsEntities = {
    users: 'users',
    rbac: 'rbac',
    settings: 'settings',
    accounts: 'accounts',
    hash: 'hash',
    forensics: 'forensics',
    deepVisibility: 'deepVisibility',
    sites: 'sites',
    reports: 'reports',
    groups: 'groups',
    agents: 'agents',
    updates: 'updates',
    policy: 'policy',
    exlusions: 'exclusions',
    system: 'system',
    configOverride: 'configOverride',
    activities: 'activities',
    agentActions: 'agentActions',
    filters: 'filters',
    tags: 'tags',
    customDetectionRules: 'customDetectionRules',
    deepVisibilityV2: 'deepVisibilityV2',
    threats: 'threats',
    authenticator: 'authenticator',
    commands: 'commands',
    applicationsRisk: 'applicationsRisk',
    fireWallControl: 'fireWallControl',
    deviceControl: 'deviceControl',
    credGroups: 'credGroups',
    credGroupDetails: 'credGroupDetails'
};
/**
 * Get End Point
 * example : getEndPoint(endPointsEntities.users,endPoints.users.userEndPointsNames.userInfo)
 * will return:
 *  userInfo {
 *      url:`private/user-info`
 *      method: HttpMethod.GET
 *    }
 * @param entityName
 * @param apiName
 */
exports.getEndPoint = function (entityName, apiName) {
    return exports.endPoints[entityName]["" + apiName];
};
//# sourceMappingURL=ends-points-entitities.js.map