"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fireWallControl = {
    getFirewallRules: { url: "firewall-control", method: "get" /* GET */ },
    createFirewallRule: { url: "firewall-control", method: "post" /* POST */ },
    createNetworkQuarantineRule: { url: "firewall-control/network-quarantine", method: "post" /* POST */ },
    createTag: { url: "tags", method: "post" /* POST */ },
    updateFirewallRule: { url: function (rulId) { return "firewall-control/" + rulId; } },
    countByFilters: { url: "private/firewall-control/filters-count", method: "get" /* GET */ },
    getUnscopedRules: { url: "private/firewall-control/unscoped", method: "get" /* GET */ },
    getConfiguration: { url: "firewall-control/configuration", method: "get" /* GET */ },
    updateConfiguration: { url: "firewall-control/configuration", method: "put" /* PUT */ },
    copyRules: { url: "firewall-control/copy-rules", method: "post" /* POST */ },
    moveRules: { url: "firewall-control/move-rules", method: "post" /* POST */ },
    getProtocols: { url: "firewall-control/protocols", method: "get" /* GET */ },
    reorderRules: { url: "firewall-control/reorder", method: "put" /* PUT */ },
    exportRules: { url: "firewall-control/export", method: "get" /* GET */ },
    importRules: { url: "firewall-control/import", method: "post" /* POST */ },
    enableDisableRules: { url: "firewall-control/enable", method: "put" /* PUT */ },
    deleteRules: { url: "firewall-control", method: "delete" /* DELETE */ }
};
var fireWallControlEndPointsTypes;
(function (fireWallControlEndPointsTypes) {
    fireWallControlEndPointsTypes["getFirewallRules"] = "getFirewallRules";
    fireWallControlEndPointsTypes["updateFirewallRule"] = "updateFirewallRule";
    fireWallControlEndPointsTypes["getUnscopedRules"] = "getUnscopedRules";
    fireWallControlEndPointsTypes["updateConfiguration"] = "updateConfiguration";
    fireWallControlEndPointsTypes["moveRules"] = "moveRules";
    fireWallControlEndPointsTypes["reorderRules"] = "reorderRules";
    fireWallControlEndPointsTypes["importRules"] = "importRules";
    fireWallControlEndPointsTypes["createFirewallRule"] = "createFirewallRule";
    fireWallControlEndPointsTypes["createNetworkQuarantineRule"] = "createNetworkQuarantineRule";
    fireWallControlEndPointsTypes["createTag"] = "createTag";
    fireWallControlEndPointsTypes["countByFilters"] = "countByFilters";
    fireWallControlEndPointsTypes["getConfiguration"] = "getConfiguration";
    fireWallControlEndPointsTypes["copyRules"] = "copyRules";
    fireWallControlEndPointsTypes["getProtocols"] = "getProtocols";
    fireWallControlEndPointsTypes["exportRules"] = "exportRules";
    fireWallControlEndPointsTypes["enableDisableRules"] = "enableDisableRules";
    fireWallControlEndPointsTypes["deleteRules"] = "deleteRules";
})(fireWallControlEndPointsTypes = exports.fireWallControlEndPointsTypes || (exports.fireWallControlEndPointsTypes = {}));
exports.fireWallControlEndPointsNames = fireWallControlEndPointsTypes;
//# sourceMappingURL=firewall-controll-endpoints.js.map