"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forensics = {
    getThreatForensicDetails: {
        url: function (threat_id) { return "threats/" + threat_id + "/forensics/details"; },
        method: "get" /* GET */
    },
    getApplicationForensicDetails: {
        url: function (payloadQuery) { return "applications/" + payloadQuery + "/forensics/details"; },
        method: "get" /* GET */
    },
    getThreatForensics: { url: function (threat_id) { return "threats/" + threat_id + "/forensics"; }, method: "get" /* GET */ },
    getApplicationForensics: {
        url: function (payloadQuery) { return "applications/" + payloadQuery + "/forensics"; },
        method: "get" /* GET */
    },
    getThreatConnections: {
        url: function (threat_id) { return "threats/" + threat_id + "/forensics/connections"; },
        method: "get" /* GET */
    },
    getApplicationConnections: {
        url: function (payloadQuery) { return "applications/" + payloadQuery + "/forensics/connections"; },
        method: "get" /* GET */
    },
    getThreatSeenOnNetwork: {
        url: function (threat_id) { return "threats/" + threat_id + "/forensics/seenOnNetwork"; },
        method: "get" /* GET */
    },
    exportThreat: {
        url: function (threat_id, export_format) {
            return "threats/" + threat_id + "/forensics/export/" + export_format;
        },
        method: "get" /* GET */
    },
    exportApplication: {
        url: function (payloadQuery) { return "applications/" + payloadQuery + "/forensics/export/" + payloadQuery; },
        method: "get" /* GET */
    }
};
var ForensicsEndpointsTypes;
(function (ForensicsEndpointsTypes) {
    ForensicsEndpointsTypes["getThreatForensicDetails"] = "getThreatForensicDetails";
    ForensicsEndpointsTypes["getApplicationForensicDetails"] = "getApplicationForensicDetails";
    ForensicsEndpointsTypes["getThreatForensics"] = "getThreatForensics";
    ForensicsEndpointsTypes["getApplicationForensics"] = "getApplicationForensics";
    ForensicsEndpointsTypes["getThreatConnections"] = "getThreatConnections";
    ForensicsEndpointsTypes["getApplicationConnections"] = "getApplicationForensics";
    ForensicsEndpointsTypes["getThreatSeenOnNetwork"] = "getThreatSeenOnNetwork";
    ForensicsEndpointsTypes["exportThreat"] = "exportThreat";
    ForensicsEndpointsTypes["exportApplication"] = "exportApplication";
})(ForensicsEndpointsTypes = exports.ForensicsEndpointsTypes || (exports.ForensicsEndpointsTypes = {}));
exports.ForensicsEndpointsNames = ForensicsEndpointsTypes;
//# sourceMappingURL=forensics-endpoints.js.map