"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.groups = {
    getGroups: {
        url: "groups",
        method: "get" /* GET */
    },
    getGroupsById: { url: function (payloadQuery) { return "groups/" + payloadQuery; }, method: "get" /* GET */ },
    getDefaultGroups: { url: "private/groups-default", method: "get" /* GET */ },
    countGroups: { url: "private/group-count", method: "get" /* GET */ },
    updateGroups: { url: function (payloadQuery) { return "groups/" + payloadQuery; }, method: "put" /* PUT */ },
    updateRanks: { url: "groups/ranks", method: "put" /* PUT */ },
    moveAgents: { url: function (payloadQuery) { return "groups/" + payloadQuery + "/move-agents"; }, method: "put" /* PUT */ },
    createGroups: { url: "groups", method: "post" /* POST */ },
    deleteGroups: { url: function (payloadQuery) { return "groups/" + payloadQuery; }, method: "delete" /* DELETE */ },
    revertGroupsPolicy: { url: function (group_id) { return "groups/" + group_id + "/revert-policy"; }, method: "put" /* PUT */ }
};
var GroupsEndPointsTypes;
(function (GroupsEndPointsTypes) {
    GroupsEndPointsTypes["getGroups"] = "getGroups";
    GroupsEndPointsTypes["getGroupsById"] = "getGroupsById";
    GroupsEndPointsTypes["getDefaultGroups"] = "getDefaultGroups";
    GroupsEndPointsTypes["countGroups"] = "countGroups";
    GroupsEndPointsTypes["updateGroups"] = "updateGroups";
    GroupsEndPointsTypes["updateRanks"] = "updateRanks";
    GroupsEndPointsTypes["moveAgents"] = "moveAgents";
    GroupsEndPointsTypes["createGroups"] = "createGroups";
    GroupsEndPointsTypes["deleteGroups"] = "deleteGroups";
    GroupsEndPointsTypes["revertGroupsPolicy"] = "revertGroupsPolicy";
})(GroupsEndPointsTypes = exports.GroupsEndPointsTypes || (exports.GroupsEndPointsTypes = {}));
exports.GroupsEndPointsNames = GroupsEndPointsTypes;
//# sourceMappingURL=groups-endpoints.js.map