import { HttpMethod } from './../enums/http-method';
export declare const settings: {
    getSYSLOG: {
        url: string;
        method: HttpMethod;
    };
    setSYSLOG: {
        url: string;
        method: HttpMethod;
    };
    getSystemConfig: {
        url: string;
        method: HttpMethod;
    };
    getADSettings: {
        url: string;
        method: HttpMethod;
    };
    getADRoleString: {
        url: string;
        method: HttpMethod;
    };
    setADRoleString: {
        url: string;
        method: HttpMethod;
    };
    setADsettings: {
        url: string;
        method: HttpMethod;
    };
    testADSettings: {
        url: string;
        method: HttpMethod;
    };
    getNotificationSettings: {
        url: string;
        method: HttpMethod;
    };
    getRecipients: {
        url: string;
        method: HttpMethod;
    };
    setNotificationSettings: {
        url: string;
        method: HttpMethod;
    };
    setNotificationRecipientsSettings: {
        url: string;
        method: HttpMethod;
    };
    clearPendingNotification: {
        url: string;
        method: HttpMethod;
    };
    getSMSettings: {
        url: string;
        method: HttpMethod;
    };
    getSMTPSettings: {
        url: string;
        method: HttpMethod;
    };
    setSMTPSettings: {
        url: string;
        method: HttpMethod;
    };
    testSMTPSettings: {
        url: string;
        method: HttpMethod;
    };
    getSSOSettings: {
        url: string;
        method: HttpMethod;
    };
    setSSOsettings: {
        url: string;
        method: HttpMethod;
    };
    testSSOSettings: {
        url: string;
        method: HttpMethod;
    };
    deleteNotificationRecipient: {
        url: (recipient_id: string) => string;
        method: HttpMethod;
    };
    testSettings: {
        url: string;
        method: HttpMethod;
    };
    testSYSLOGSettings: {
        url: string;
        method: HttpMethod;
    };
    getWdaptSettings: {
        url: string;
        methode: HttpMethod;
    };
    setWdaptSettings: {
        url: string;
        method: HttpMethod;
    };
    testWdaptSettings: {
        url: string;
        method: HttpMethod;
    };
};
export declare enum WDAPTEndPointsTypes {
    getWdaptSettings = "getWdaptSettings",
    setWdaptSettings = "setWdaptSettings",
    testWdaptSettings = "testWdaptSettings"
}
export declare const WDAPTEndPointEndPointsNames: typeof WDAPTEndPointsTypes;
export declare enum ActiveDirectoryEndPointsTypes {
    getADSettings = "getADSettings",
    getADRoleString = "getADRoleString",
    setADRoleString = "setADRoleString",
    setADsettings = "setADsettings",
    testADSettings = "testADSettings"
}
export declare const ActiveDirectoryEndPointsNames: typeof ActiveDirectoryEndPointsTypes;
export declare enum SyslogEndPointsTypes {
    getSYSLOG = "getSYSLOG",
    setSYSLOG = "setSYSLOG",
    testSYSLOGSettings = "testSYSLOGSettings"
}
export declare const SyslogEndPointsNames: typeof SyslogEndPointsTypes;
export declare enum SMTPEndPointsTypes {
    getSMTPSettings = "getSMTPSettings",
    setSMTPSettings = "setSMTPSettings",
    testSMTPSettings = "testSMTPSettings"
}
export declare const SMTPEndPointsNames: typeof SMTPEndPointsTypes;
export declare enum SSOEndPointsTypes {
    getSSOSettings = "getSSOSettings",
    setSSOsettings = "setSSOsettings",
    testSSOSettings = "testSSOSettings"
}
export declare const SSOEndPointsNames: typeof SSOEndPointsTypes;
export declare enum NotificationEndPointsTypes {
    getNotificationSettings = "getNotificationSettings",
    getRecipients = "getRecipients",
    getSMSettings = "getSMSettings",
    setNotificationSettings = "setNotificationSettings",
    setNotificationRecipientsSettings = "setNotificationRecipientsSettings",
    deleteNotificationRecipient = "deleteNotificationRecipient",
    clearPendingNotification = "clearPendingNotification"
}
export declare const NotificationEndPointsNames: typeof NotificationEndPointsTypes;
export declare enum SettingsEndPointsTypes {
    getSystemConfig = "getSystemConfig",
    testSettings = "testSettings"
}
export declare const SettingsEndPointsNames: {
    [x: number]: string;
    getWdaptSettings: WDAPTEndPointsTypes.getWdaptSettings;
    setWdaptSettings: WDAPTEndPointsTypes.setWdaptSettings;
    testWdaptSettings: WDAPTEndPointsTypes.testWdaptSettings;
    getSSOSettings: SSOEndPointsTypes.getSSOSettings;
    setSSOsettings: SSOEndPointsTypes.setSSOsettings;
    testSSOSettings: SSOEndPointsTypes.testSSOSettings;
    getNotificationSettings: NotificationEndPointsTypes.getNotificationSettings;
    getRecipients: NotificationEndPointsTypes.getRecipients;
    getSMSettings: NotificationEndPointsTypes.getSMSettings;
    setNotificationSettings: NotificationEndPointsTypes.setNotificationSettings;
    setNotificationRecipientsSettings: NotificationEndPointsTypes.setNotificationRecipientsSettings;
    deleteNotificationRecipient: NotificationEndPointsTypes.deleteNotificationRecipient;
    clearPendingNotification: NotificationEndPointsTypes.clearPendingNotification;
    getSYSLOG: SyslogEndPointsTypes.getSYSLOG;
    setSYSLOG: SyslogEndPointsTypes.setSYSLOG;
    testSYSLOGSettings: SyslogEndPointsTypes.testSYSLOGSettings;
    getADSettings: ActiveDirectoryEndPointsTypes.getADSettings;
    getADRoleString: ActiveDirectoryEndPointsTypes.getADRoleString;
    setADRoleString: ActiveDirectoryEndPointsTypes.setADRoleString;
    setADsettings: ActiveDirectoryEndPointsTypes.setADsettings;
    testADSettings: ActiveDirectoryEndPointsTypes.testADSettings;
    getSystemConfig: SettingsEndPointsTypes.getSystemConfig;
    testSettings: SettingsEndPointsTypes.testSettings;
};
