"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.settings = {
    getSYSLOG: { url: "settings/syslog", method: "get" /* GET */ },
    setSYSLOG: { url: "settings/syslog", method: "put" /* PUT */ },
    getSystemConfig: { url: "private/settings/system-configuration", method: "get" /* GET */ },
    getADSettings: { url: "settings/active-directory", method: "get" /* GET */ },
    getADRoleString: { url: 'settings/active-directory/scope-mapping', method: "get" /* GET */ },
    setADRoleString: { url: 'settings/active-directory/scope-mapping', method: "put" /* PUT */ },
    setADsettings: { url: 'settings/active-directory', method: "put" /* PUT */ },
    testADSettings: { url: 'settings/active-directory/test', method: "post" /* POST */ },
    getNotificationSettings: { url: "settings/notifications", method: "get" /* GET */ },
    getRecipients: { url: "settings/recipients", method: "get" /* GET */ },
    setNotificationSettings: { url: 'settings/notifications', method: "put" /* PUT */ },
    setNotificationRecipientsSettings: { url: 'settings/recipients', method: "put" /* PUT */ },
    clearPendingNotification: { url: 'settings/notifications/cancel-pending-emails', method: "post" /* POST */ },
    getSMSettings: { url: "settings/sms", method: "get" /* GET */ },
    getSMTPSettings: { url: "settings/smtp", method: "get" /* GET */ },
    setSMTPSettings: { url: 'settings/smtp', method: "put" /* PUT */ },
    testSMTPSettings: { url: 'settings/smtp/test', method: "post" /* POST */ },
    getSSOSettings: { url: "settings/sso", method: "get" /* GET */ },
    setSSOsettings: { url: 'settings/sso', method: "put" /* PUT */ },
    testSSOSettings: { url: 'settings/sso/test', method: "post" /* POST */ },
    deleteNotificationRecipient: {
        url: function (recipient_id) { return "settings/recipients/" + recipient_id; },
        method: "delete" /* DELETE */
    },
    testSettings: { url: "settings/smtp/test", method: "post" /* POST */ },
    testSYSLOGSettings: { url: "settings/syslog/test", method: "post" /* POST */ },
    getWdaptSettings: { url: 'settings/microsoft', methode: "get" /* GET */ },
    setWdaptSettings: { url: 'settings/microsoft', method: "put" /* PUT */ },
    testWdaptSettings: { url: 'settings/microsoft/test', method: "post" /* POST */ }
};
// ----------------WDAPTEndPointsTypes-----------------------
var WDAPTEndPointsTypes;
(function (WDAPTEndPointsTypes) {
    WDAPTEndPointsTypes["getWdaptSettings"] = "getWdaptSettings";
    WDAPTEndPointsTypes["setWdaptSettings"] = "setWdaptSettings";
    WDAPTEndPointsTypes["testWdaptSettings"] = "testWdaptSettings";
})(WDAPTEndPointsTypes = exports.WDAPTEndPointsTypes || (exports.WDAPTEndPointsTypes = {}));
exports.WDAPTEndPointEndPointsNames = WDAPTEndPointsTypes;
// ----------------// WDAPTEndPointsTypes-----------------------
// ----------------ActiveDirectoryEndPointsTypes-----------------------
var ActiveDirectoryEndPointsTypes;
(function (ActiveDirectoryEndPointsTypes) {
    ActiveDirectoryEndPointsTypes["getADSettings"] = "getADSettings";
    ActiveDirectoryEndPointsTypes["getADRoleString"] = "getADRoleString";
    ActiveDirectoryEndPointsTypes["setADRoleString"] = "setADRoleString";
    ActiveDirectoryEndPointsTypes["setADsettings"] = "setADsettings";
    ActiveDirectoryEndPointsTypes["testADSettings"] = "testADSettings";
})(ActiveDirectoryEndPointsTypes = exports.ActiveDirectoryEndPointsTypes || (exports.ActiveDirectoryEndPointsTypes = {}));
exports.ActiveDirectoryEndPointsNames = ActiveDirectoryEndPointsTypes;
// ----------------// ActiveDirectoryEndPointsTypes-----------------------
// ----------------SyslogEndPointsTypes-----------------------
var SyslogEndPointsTypes;
(function (SyslogEndPointsTypes) {
    SyslogEndPointsTypes["getSYSLOG"] = "getSYSLOG";
    SyslogEndPointsTypes["setSYSLOG"] = "setSYSLOG";
    SyslogEndPointsTypes["testSYSLOGSettings"] = "testSYSLOGSettings";
})(SyslogEndPointsTypes = exports.SyslogEndPointsTypes || (exports.SyslogEndPointsTypes = {}));
exports.SyslogEndPointsNames = SyslogEndPointsTypes;
// ----------------SyslogEndPointsTypes-----------------------
// ----------------SMTPEndPointsTypes-----------------------
var SMTPEndPointsTypes;
(function (SMTPEndPointsTypes) {
    SMTPEndPointsTypes["getSMTPSettings"] = "getSMTPSettings";
    SMTPEndPointsTypes["setSMTPSettings"] = "setSMTPSettings";
    SMTPEndPointsTypes["testSMTPSettings"] = "testSMTPSettings";
})(SMTPEndPointsTypes = exports.SMTPEndPointsTypes || (exports.SMTPEndPointsTypes = {}));
exports.SMTPEndPointsNames = SMTPEndPointsTypes;
// ----------------// SMTPEndPointsTypes--------------------
// ----------------SSOEndPointsTypes-----------------------
var SSOEndPointsTypes;
(function (SSOEndPointsTypes) {
    SSOEndPointsTypes["getSSOSettings"] = "getSSOSettings";
    SSOEndPointsTypes["setSSOsettings"] = "setSSOsettings";
    SSOEndPointsTypes["testSSOSettings"] = "testSSOSettings";
})(SSOEndPointsTypes = exports.SSOEndPointsTypes || (exports.SSOEndPointsTypes = {}));
exports.SSOEndPointsNames = SSOEndPointsTypes;
// ----------------// SSOEndPointsTypes-----------------------
// ---------------- NotificationEndPointsTypes----------------
var NotificationEndPointsTypes;
(function (NotificationEndPointsTypes) {
    NotificationEndPointsTypes["getNotificationSettings"] = "getNotificationSettings";
    NotificationEndPointsTypes["getRecipients"] = "getRecipients";
    NotificationEndPointsTypes["getSMSettings"] = "getSMSettings";
    NotificationEndPointsTypes["setNotificationSettings"] = "setNotificationSettings";
    NotificationEndPointsTypes["setNotificationRecipientsSettings"] = "setNotificationRecipientsSettings";
    NotificationEndPointsTypes["deleteNotificationRecipient"] = "deleteNotificationRecipient";
    NotificationEndPointsTypes["clearPendingNotification"] = "clearPendingNotification";
})(NotificationEndPointsTypes = exports.NotificationEndPointsTypes || (exports.NotificationEndPointsTypes = {}));
exports.NotificationEndPointsNames = NotificationEndPointsTypes;
// ----------------// NotificationEndPointsTypes-----------------------
var SettingsEndPointsTypes;
(function (SettingsEndPointsTypes) {
    SettingsEndPointsTypes["getSystemConfig"] = "getSystemConfig";
    SettingsEndPointsTypes["testSettings"] = "testSettings";
})(SettingsEndPointsTypes = exports.SettingsEndPointsTypes || (exports.SettingsEndPointsTypes = {}));
exports.SettingsEndPointsNames = __assign({}, SettingsEndPointsTypes, exports.ActiveDirectoryEndPointsNames, exports.SyslogEndPointsNames, exports.NotificationEndPointsNames, exports.SSOEndPointsNames, exports.WDAPTEndPointEndPointsNames);
//# sourceMappingURL=settings-endpoints.js.map