"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sites = {
    getSites: {
        url: "sites",
        method: "get" /* GET */
    },
    getSiteById: {
        url: function (payloadQuery) { return "sites/" + payloadQuery; },
        method: "get" /* GET */
    },
    getSitePolicy: {
        url: function (payloadQuery) { return "sites/" + payloadQuery + "/policy"; },
        method: "get" /* GET */
    },
    expireSite: {
        url: function (payloadQuery) { return "sites/" + payloadQuery + "/expire-now"; },
        method: "post" /* POST */
    },
    createSite: {
        url: "sites",
        method: "post" /* POST */
    },
    regenerateSiteKey: {
        url: function (payloadQuery) {
            return "sites/" + payloadQuery + "/regenerate-key";
        },
        method: "put" /* PUT */
    },
    createWithAdmin: {
        url: "site-with-admin",
        method: "post" /* POST */
    },
    revertSitePolicy: {
        url: function (payloadQuery) { return "sites/" + payloadQuery + "/revert-policy"; },
        method: "put" /* PUT */
    },
    updateSite: {
        url: function (payloadQuery) { return "sites/" + payloadQuery; },
        method: "put" /* PUT */
    },
    updateSitePolicy: {
        url: function (payloadQuery) { return "sites/" + payloadQuery + "/policy"; },
        method: "put" /* PUT */
    },
    reactivateSite: {
        url: function (payloadQuery) { return "sites/" + payloadQuery + "/reactivate"; },
        method: "put" /* PUT */
    },
    deleteSite: {
        url: function (payloadQuery) { return "sites/" + payloadQuery; },
        method: "delete" /* DELETE */
    }
};
var SitesEndPointTypes;
(function (SitesEndPointTypes) {
    SitesEndPointTypes["getSites"] = "getSites";
    SitesEndPointTypes["getSiteById"] = "getSiteById";
    SitesEndPointTypes["getSitePolicy"] = "getSitePolicy";
    SitesEndPointTypes["expireSite"] = "expireSite";
    SitesEndPointTypes["createSite"] = "createSite";
    SitesEndPointTypes["regenerateSiteKey"] = "regenerateSiteKey";
    SitesEndPointTypes["createWithAdmin"] = "createWithAdmin";
    SitesEndPointTypes["revertSitePolicy"] = "revertSitePolicy";
    SitesEndPointTypes["updateSite"] = "updateSite";
    SitesEndPointTypes["updateSitePolicy"] = "updateSitePolicy";
    SitesEndPointTypes["reactivateSite"] = "reactivateSite";
    SitesEndPointTypes["deleteSite"] = "deleteSite";
})(SitesEndPointTypes = exports.SitesEndPointTypes || (exports.SitesEndPointTypes = {}));
exports.SitesEndPointsNames = SitesEndPointTypes;
//# sourceMappingURL=sites-endpoints.js.map