import { HttpMethod } from '../enums/http-method';
export declare enum ThreatEndPointsNames {
    getAllThreat = "getAllThreat",
    countByFilters = "countByFilters",
    threatGroups = "threatGroups",
    getThreatsSummery = "getThreatsSummery",
    markAsThreat = "markAsThreat",
    markAsResolved = "markAsResolved",
    disableEngines = "disableEngines",
    mitigateThreats = "mitigateThreats",
    addToBlackList = "addToBlackList",
    markAsBenign = "markAsBenign",
    getNotes = "getNotes",
    addNote = "addNote",
    editNote = "editNote",
    deleteNote = "deleteNote"
}
export declare const threats: {
    threatsSummery: {
        url: string;
        method: HttpMethod;
    };
    mitigateThreats: {
        url: string;
        method: HttpMethod;
    };
    threatGroups: {
        url: string;
        method: HttpMethod;
    };
    countByFilters: {
        url: string;
        method: HttpMethod;
    };
    markAsResolved: {
        url: string;
        method: HttpMethod;
    };
    addToBlackList: {
        url: string;
        method: HttpMethod;
    };
    markAsBenign: {
        url: string;
        method: HttpMethod;
    };
    markAsThreat: {
        url: string;
        method: HttpMethod;
    };
    disableEngines: {
        url: string;
        method: HttpMethod;
    };
    updateThreat: {
        url: string;
        method: HttpMethod;
    };
    getNotes: {
        url: (threadId: string) => string;
        method: HttpMethod;
    };
    addNote: {
        url: string;
        method: HttpMethod;
    };
    editNote: {
        url: (threadId: string, noteId: string) => string;
        method: HttpMethod;
    };
    deleteNote: {
        url: (threadId: string, noteId: string) => string;
        method: HttpMethod;
    };
};
export declare const ThreatApiEndPointsNames: typeof ThreatEndPointsNames;
