"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ThreatEndPointsNames;
(function (ThreatEndPointsNames) {
    ThreatEndPointsNames["getAllThreat"] = "getAllThreat";
    ThreatEndPointsNames["countByFilters"] = "countByFilters";
    ThreatEndPointsNames["threatGroups"] = "threatGroups";
    ThreatEndPointsNames["getThreatsSummery"] = "getThreatsSummery";
    ThreatEndPointsNames["markAsThreat"] = "markAsThreat";
    ThreatEndPointsNames["markAsResolved"] = "markAsResolved";
    ThreatEndPointsNames["disableEngines"] = "disableEngines";
    ThreatEndPointsNames["mitigateThreats"] = "mitigateThreats";
    ThreatEndPointsNames["addToBlackList"] = "addToBlackList";
    ThreatEndPointsNames["markAsBenign"] = "markAsBenign";
    ThreatEndPointsNames["getNotes"] = "getNotes";
    ThreatEndPointsNames["addNote"] = "addNote";
    ThreatEndPointsNames["editNote"] = "editNote";
    ThreatEndPointsNames["deleteNote"] = "deleteNote";
})(ThreatEndPointsNames = exports.ThreatEndPointsNames || (exports.ThreatEndPointsNames = {}));
exports.threats = {
    threatsSummery: {
        url: "private/threats/summary",
        method: "get" /* GET */
    },
    mitigateThreats: {
        url: "threats/mitigate",
        method: "post" /* POST */
    },
    threatGroups: {
        url: "private/threat-groups",
        method: "get" /* GET */
    },
    countByFilters: {
        url: "private/threats/filters-count",
        method: "get" /* GET */
    },
    markAsResolved: {
        url: "threats/mark-as-resolved",
        method: "post" /* POST */
    },
    addToBlackList: {
        url: "threats/add-to-blacklist",
        method: "post" /* POST */
    },
    markAsBenign: {
        url: "threats/mark-as-benign",
        method: "post" /* POST */
    },
    markAsThreat: {
        url: "threats/mark-as-threat",
        method: "post" /* POST */
    },
    disableEngines: {
        url: "threats/engines/disable",
        method: "post" /* POST */
    },
    updateThreat: {
        url: "threats",
        method: "put" /* PUT */
    },
    getNotes: {
        url: function (threadId) { return "threats/" + threadId + "/notes"; },
        method: "get" /* GET */
    },
    addNote: {
        url: 'threats/notes',
        method: "post" /* POST */
    },
    editNote: {
        url: function (threadId, noteId) { return "threats/" + threadId + "/notes/" + noteId; },
        method: "put" /* PUT */
    },
    deleteNote: {
        url: function (threadId, noteId) { return "threats/" + threadId + "/notes/" + noteId; },
        method: "delete" /* DELETE */
    }
};
exports.ThreatApiEndPointsNames = ThreatEndPointsNames;
//# sourceMappingURL=threat-endpoints.js.map