"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var UserEndPointsType;
(function (UserEndPointsType) {
    UserEndPointsType["userInfo"] = "userInfo";
    UserEndPointsType["checkTenantAdmin"] = "checkTenantAdmin";
    UserEndPointsType["userByToken"] = "userByToken";
    UserEndPointsType["getUserById"] = "getUserById";
    UserEndPointsType["requestTwoFaApp"] = "requestTwoFaApp";
    UserEndPointsType["generateRecoveryCode"] = "generateRecoveryCode";
    UserEndPointsType["generateIframeToken"] = "generateIframeToken";
    UserEndPointsType["generateApiToken"] = "generateApiToken";
    UserEndPointsType["createUsers"] = "createUsers";
    UserEndPointsType["deleteUser"] = "deleteUser";
    UserEndPointsType["updateUser"] = "updateUser";
    UserEndPointsType["disableToFa"] = "disableToFa";
    UserEndPointsType["enableTwoFa"] = "enableTwoFa";
    UserEndPointsType["revokeApiToken"] = "revokeApiToken";
    UserEndPointsType["changePassword"] = "changePassword";
    UserEndPointsType["singInWithEula"] = "singInWithEula";
    UserEndPointsType["verifyEmail"] = "verifyEmail";
    UserEndPointsType["verifyCode"] = "verifyCode";
    UserEndPointsType["checkViewerAuth"] = "checkViewerAuth";
    UserEndPointsType["enableTwoFaApp"] = "enableTwoFaApp";
    UserEndPointsType["apiTokenDetails"] = "apiTokenDetails";
    UserEndPointsType["getUsers"] = "getUsers";
    UserEndPointsType["enroll2fa"] = "enroll2fa";
    UserEndPointsType["resetPasswordOnNextLogin"] = "resetPasswordOnNextLogin";
})(UserEndPointsType = exports.UserEndPointsType || (exports.UserEndPointsType = {}));
exports.users = {
    userInfo: { url: "private/user-info", method: "get" /* GET */ },
    checkTenantAdmin: { url: "users/tenant-admin-auth-check", method: "get" /* GET */ },
    apiTokenDetails: { url: function (userId) { return "users/" + userId + "/api-token-details"; }, method: "get" /* GET */ },
    userByToken: { url: "user", method: "get" /* GET */ },
    getUserById: { url: function (token) { return "users/" + token; }, method: "get" /* GET */ },
    requestTwoFaApp: { url: "/users/request-app", method: "post" /* POST */ },
    generateRecoveryCode: { url: "users/generate-recovery-codes", method: "post" /* POST */ },
    generateIframeToken: { url: "users/generate-iframe-token", method: "post" /* POST */ },
    generateApiToken: { url: "users/generate-api-token", method: "post" /* POST */ },
    createUsers: { url: "users", method: "post" /* POST */ },
    deleteUser: { url: "users/", method: "delete" /* DELETE */ },
    updateUser: { url: function (user_id) { return "users/" + user_id; }, method: "put" /* PUT */ },
    disableToFa: { url: "users/2fa/disable", method: "post" /* POST */ },
    enableTwoFa: { url: "users/2fa/enable", method: "post" /* POST */ },
    revokeApiToken: { url: "users/revoke-api-token", method: "post" /* POST */ },
    changePassword: { url: "users/change-password", method: "post" /* POST */ },
    singInWithEula: { url: "users/auth/eula", method: "post" /* POST */ },
    verifyEmail: { url: "users/send-verification-email", method: "post" /* POST */ },
    verifyCode: { url: "users/user-code-verification", method: "get" /* GET */ },
    checkViewerAuth: { url: "users/viewer-auth-check", method: "get" /* GET */ },
    enableTwoFaApp: { url: "users/enable-app", method: "post" /* POST */ },
    getUsers: { url: "users", method: "get" /* GET */ },
    enroll2fa: { url: "users/enroll-2fa", method: "post" /* POST */ },
    resetPasswordOnNextLogin: { url: 'users/login/force-reset-password-on-login', method: "post" /* POST */ }
};
exports.UsersEndPointsNames = UserEndPointsType;
//# sourceMappingURL=users-endpoints.js.map