import { SDKRespond } from '../../services/modal/sdk-respond-interface';
import { ApiCall } from '../../services/api-call';
import { EntityBaseClass } from '../entity-base-class';
import { GetAgentRequest } from './modal/get-agents.interface';
export declare class Agents extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    /**
     * Get() = getAgents()
     * alias name fot getAgent function
     * get() represent the default get function fot this instance
     */
    get(data?: GetAgentRequest): Promise<SDKRespond>;
    /**
     * Get Applications
     * GET : /web/api/v2.0/agents/applications
     * Retrieve running applications for a specific agent.
     */
    getApplications(ids?: string[]): Promise<SDKRespond>;
    /**
     * Get Paraphrases
     * Generate Paraphrases for the agents matching the input filter.
     * GET : Generate Paraphrases for the agents matching the input filter.
     */
    getParaphrases(): Promise<SDKRespond>;
    /**
     * Agent Count Summery
     * GET: /web/api/v2.0/private/agents/summary
     * Summary of agents by numbers.
     */
    agentCountSummery(): Promise<SDKRespond>;
    /**
     * Count Agents
     * GET: /web/api/v2.0/agents/count
     * Count number of agents matching the supplied filter arguments.
     */
    countAgents(): Promise<SDKRespond>;
    /**
     * Count Agents By Filters
     * GET: /web/api/v2.0/private/agents/filters-count
     * Show a count of agent per filter value.
     * @param filters
     */
    countAgentsByFilters(filters: any): Promise<SDKRespond>;
}
