import { BaseGetQueryParams } from '../../../model/base-get.interface';
import { BaseThreatsCreatedAtFilter } from '../../../model/ threat-created-at-filter.interface';
import { BaseTotalMemoryFilter } from '../../../model/base-total-memory-filter.interface';
import { BaseLastActiveDateFilter } from '../../../model/base-last-active-date-filter.interface';
import { ScanStatus } from '../../../enums/scan-status-type';
import { OsTypes } from '../../../enums/os-types';
import { NetworkStatusesTypes } from '../../../enums/network-statuses-types';
import { BaseCoreFilter } from '../../../model/base-core-count-filter.interface';
import { OsArchs } from '../../../enums/os-archs-types';
import { AgentMachineTypes } from '../../../enums/agent-machine-types';
import { UserActionsNeeded } from '../../../enums/user-actions-needed-types';
import { MitigationModeSuspicious } from '../../../enums/mitigation-mode-suspicious-types';
export interface GetAgentRequest extends BaseGetQueryParams, BaseThreatsCreatedAtFilter, BaseTotalMemoryFilter, BaseLastActiveDateFilter, BaseCoreFilter {
    countOnly?: boolean;
    skipCount?: boolean;
    limit?: number;
    isDecommissioned?: boolean;
    isUninstalled?: boolean;
    isPendingUninstall?: boolean;
    computerName__like?: string;
    computerName?: string;
    adQuery?: string;
    agentVersions?: string[];
    threatContentHash?: string;
    uuids?: string[];
    uuid?: string[];
    osTypes?: OsTypes[] | OsTypes;
    scanStatuses?: ScanStatus[];
    encryptedApplications?: boolean;
    networkStatuses?: NetworkStatusesTypes[];
    osArch?: OsArchs;
    domains?: string[];
    agentMachineTypes?: AgentMachineTypes[];
    threatMitigationStatus?: MitigationModeSuspicious;
    threatResolved?: boolean;
    activeThreats?: number;
    filterId?: string;
    isActive?: boolean;
    userActionsNeeded?: UserActionsNeeded;
    mitigationMode?: MitigationModeSuspicious;
    hasLocalConfiguration?: boolean;
    threatHidden?: boolean;
    infected?: boolean;
    isUpToDate?: boolean;
}
