"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var entity_base_class_1 = require("../entity-base-class");
var agent_action_endpoints_1 = require("../../end-point-entitity/agent-action-endpoints");
/**
 * Agent Actions
 *
 * @export
 * @class AgentActions
 * @extends {EntityBaseClass}
 */
var AgentActions = /** @class */ (function (_super) {
    __extends(AgentActions, _super);
    function AgentActions(apiCall) {
        var _this = _super.call(this, agent_action_endpoints_1.AgentActionsEndPointsNames, ends_points_entitities_1.endPointsEntities.agentActions, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * get() = Fetch logs()
     *
     * @param {GetAgentRequest} filters
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.get = function (filters) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.fetchLogs(filters)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Fetch logs
     *
     * Sends a "fetch logs" command to all agents matching the input filter.
     * This Method sends creation of log file to the agent
     * The final result is can be shown in Activities by getting a a link to logs files
     * it could take a while to this action to take place.
     *
     * POST : /web/api/v2.0/agents/actions/fetch-logs
     *
     * @param {GetAgentRequest} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.fetchLogs = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.fetchLogs, { filter: { filter: filter } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Abort Scan
     *
     * Aborts running scan on all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/abort-scan
     *
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.abortScan = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.abortScan, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Approve Uninstall
     *
     * Approve uninstall requests for all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/approve-uninstall
     *
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.approveUninstall = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.approveUninstall, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Broadcast Message
     *
     * Broadcasts a message to all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/broadcast
     *
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.broadcastMessage = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.broadcastMessage, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Connect to network - Sends a "connect to network" command to all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/connect
     * @param data : AgentActionsRequest
     */
    AgentActions.prototype.connectToNetwork = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.connectToNetwork, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Decommission
     *
     * Decommissions all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/decommission
     *
     * @param data : : AgentActionsRequest
     */
    AgentActions.prototype.decommission = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.decommission, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Disconnect From Network
     *
     *
     * Sends a "disconnect from network" command to all agents matching the input filter.
     * POST :  /web/api/v2.0/agents/actions/disconnect
     *
     * @param {AgentActionsRequest} data
     * @returns
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.disconnectFromNetwork = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.disconnectFromNetwork, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Initial Scan
     *
     *  POST :  /web/api/v2.0/agents/actions/initiate-scan
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.initiateScan = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.initiateScan, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_9 = _a.sent();
                        throw err_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Move Specified Agents To Target Site
     *
     * Move specified agents to (default group of) target site
     * POST : /web/api/v2.0/agents/actions/move-to-site
     *
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.moveSpecifiedAgentsToTargetSite = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.moveAgentsToSite, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_10 = _a.sent();
                        throw err_10;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Reject Uninstall
     *
     * Reject uninstall requests for all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/reject-uninstall
     *
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.rejectUninstall = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.rejectUninstall, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_11 = _a.sent();
                        throw err_11;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Reset Local Config To Policy
     *
     * Reset policy overrides set by SentinelCtl for all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/reset-local-config
     *
     * @param {AgentActionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.resetLocalConfigToPolicy = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.resetLocalConfig, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_12 = _a.sent();
                        throw new err_12();
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Reset
     *
     * Sends a restart command to all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/restart-machine
     *
     * @param {*} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.reset = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_13;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.restart, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_13 = _a.sent();
                        throw err_13;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set Persistent Configuration Overrides
     *
     * POST : /web/api/v2.0/agents/actions/set-config
     * Set persistent configuration overrides for all agents matching the input filter.
     *
     * @param {*} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.setPersistentConfigurationOverrides = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_14;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.setPersistentConfigOverrides, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_14 = _a.sent();
                        throw err_14;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Shutdown
     *
     * Sends a shutdown command to all agents matching the input filter.
     * POST : /web/api/v2.0/agents/actions/shutdown
     *
     * @param {*} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.shutdown = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_15;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.shutdown, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_15 = _a.sent();
                        throw err_15;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Uninstall
     *
     * POST : /web/api/v2.0/agents/actions/uninstall
     * Sends an uninstall command to all agents matching the input filter.
     * @param {*} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.uninstall = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_16;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.uninstall, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_16 = _a.sent();
                        throw err_16;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update Software
     *
     * Send update software command to all agents matching the input filter.
     * POST: /web/api/v2.0/agents/actions/update-software
     *
     * @param {*} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.updateSoftware = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_17;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateSoftware, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_17 = _a.sent();
                        throw err_17;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Fetch Files
     *
     * Fetch files from agents (up to 10MB per action)
     * POST : /web/api/v2.0/agents/{agent_id}/actions/fetch-files
     *
     * @param {*} data
     * @param {string} agentId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf AgentActions
     */
    AgentActions.prototype.fetchFiles = function (data, agentId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_18;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.fetchFiels, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_18 = _a.sent();
                        throw err_18;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return AgentActions;
}(entity_base_class_1.EntityBaseClass));
exports.AgentActions = AgentActions;
//# sourceMappingURL=agent-actions.class.js.map