import { BaseGetQueryParams } from '../../../model/base-get.interface';
import { OsTypes } from './../../../enums/os-types';
import { OsArchs } from './../../../enums/os-archs-types';
import { BaseAgentFilter } from './base-agent-filter.interface';
import { ScanStatus } from '../../../enums/scan-status-type';
import { MitigationStatus } from '../../../enums/mitigation-status-type';
import { UserActionsNeeded } from '../../../enums/user-actions-needed-types';
import { AgentMachineTypes } from '../../../enums/agent-machine-types';
import { MitigationModeSuspicious } from '../../../enums/mitigation-mode-suspicious-types';
export interface AgentActionsRequest extends BaseGetQueryParams, BaseAgentFilter {
    filterId?: string;
    isActive?: boolean;
    localConfiguration?: string;
    networkStatuses?: string;
    osArch?: OsArchs[];
    osTypes?: OsTypes[];
    scanStatuses?: ScanStatus[];
    scanStatus?: ScanStatus;
    uuid?: string;
    uuids?: string;
    isPendingUninstall?: boolean;
    threatHidden?: boolean;
    mitigationModeSuspicious?: MitigationModeSuspicious;
    userActionsNeeded?: UserActionsNeeded;
    encryptedApplications?: boolean;
    infected?: boolean;
    adQuery?: string;
    threatResolved?: boolean;
    threatMitigationStatus?: MitigationStatus;
    machineTypes?: AgentMachineTypes[];
    mitigationMode?: MitigationModeSuspicious;
    threatContentHash?: string;
    hasLocalConfiguration?: boolean;
    isUninstalled?: boolean;
    agentVersions?: string[];
    domains?: string[];
    isUpToDate?: boolean;
    isDecommissioned?: boolean[];
}
