import { EntityBaseClass } from './../../entities/entity-base-class';
import { ApiCall } from './../../services/api-call';
import { SDKRespond } from './../../services/modal/sdk-respond-interface';
/**
 * ApplicationsRisk
 *
 * @export
 * @class ApplicationsRisk
 * @extends {EntityBaseClass}
 */
export declare class ApplicationsRisk extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    /**
     * GET
     *
     * @returns {Promise<any>}
     * @memberof ApplicationsRisk
     */
    get(): Promise<any>;
    /**
     * Get Applications List
     *
     * @param {*} [filters]
     * @returns {Promise<SDKRespond>}
     * @memberof ApplicationsRisk
     */
    getApplicationsList(filters?: any): Promise<SDKRespond>;
    /**
     * Get Applications Risk Levels
     *
     * @param {*} [filters]
     * @returns {Promise<SDKRespond>}
     * @memberof ApplicationsRisk
     */
    getApplicationsRiskLevels(filters?: any): Promise<SDKRespond>;
    /**
     * Get Application CVE
     *
     * @param {string} applicationAgentId
     * @returns
     * @memberof ApplicationsRisk
     */
    getApplicationCVE(applicationAgentId: string): Promise<SDKRespond>;
    /**
     * Not Implemented yet
     *
     * @memberof ApplicationsRisk
     */
    export(): void;
}
