import { SDKRespond } from '../../services/modal/sdk-respond-interface';
import { ApiCall } from '../../services/api-call';
import { EntityBaseClass } from '../entity-base-class';
import { GetCommandRequest } from './modal/get-commands-request';
/**
 * Commands
 *
 * @export
 * @class Commands
 * @extends {EntityBaseClass}
 */
export declare class Commands extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    /**
     * Get Commands
     *
     * GET : /web/api/v2.0/private/commands
     * Returns a list of commands by filter.
     *
     * @param {GetCommandRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Commands
     */
    get(data?: GetCommandRequest): Promise<SDKRespond>;
}
