import { SortOrder } from '../../../enums/sort-order-types';
import { BaseUpdateFilter } from '../../../model/base-update-filter.interface';
import { CommandNamesTypes } from '../../../enums/command-names-types';
import { BaseScope } from '../../../model/scope-get.interface';
import { BaseThreatsCreatedAtFilter } from '../../../model/ threat-created-at-filter.interface';
export declare type status = 'canceled' | 'acknowledged' | 'pending' | 'sent';
export interface GetCommandRequest extends BaseThreatsCreatedAtFilter, BaseUpdateFilter, BaseScope {
    sentAt__lte?: string;
    sentAt__lt?: string;
    sentAt__between?: string;
    sentAt__gt?: string;
    sentAt__gte?: string;
    ids?: string[];
    names?: CommandNamesTypes;
    agentUuid?: string;
    agentids?: string[];
    agentId?: string;
    skip?: number;
    acknowledgedAt__lte?: string;
    acknowledgedAt__gte?: string;
    acknowledgedAt__between?: string;
    acknowledgedAt__lt?: string;
    acknowledgedAt__gt?: string;
    sortOrder?: SortOrder;
    agentIds?: string[];
    status?: status;
    statuses?: status[];
    countOnly?: boolean;
    uuids?: string[];
    limit?: number;
    cursor?: string;
}
