import { ApiCall } from '../../services/api-call';
import { EntityBaseClass } from '../entity-base-class';
import { ConfigOverRideRequest } from './modal/configoverrride-request.interface';
import { CreateUpdateConfigOverRide } from './modal/create-configoveride-request.interface';
import { SDKRespond } from '../../services/modal/sdk-respond-interface';
/**
 * N/A INFORMATION :
 *    Please provide informatin about the functioniality of this Entity
 *
 * @export
 * @class ConfigOverRide
 * @extends {EntityBaseClass}
 */
export declare class ConfigOverRide extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    /**
     * Get
     *
     * GET :  /web/api/v2.0/config-override
     * Gets the config overrides.
     *
     * @param {ConfigOverRideRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ConfigOverRide
     */
    get(data?: ConfigOverRideRequest): Promise<SDKRespond>;
    /**
     * Create
     *
     * POST : /web/api/v2.0/config-override
     * Creates a new config override.
     *
     * @param {*} data
     * @returns
     *
     * @memberOf ConfigOverRide
     */
    create(data: CreateUpdateConfigOverRide): Promise<SDKRespond>;
    /**
     * Update
     *
     * PUT: /web/api/v2.0/config-override/{override_id}
     * Updates the config override data.
     *
     * @param {CreateUpdateConfigOverRide} data
     * @param {string} override_id
     * @returns
     *
     * @memberOf ConfigOverRide
     */
    update(data: CreateUpdateConfigOverRide, override_id: string): Promise<SDKRespond>;
    /**
     * Delete
     *
     * Deletes the config override.
     * DELETE :  /web/api/v2.0/config-override/{override_id}
     *
     * @param {string} override_id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ConfigOverRide
     */
    delete(override_id: string): Promise<SDKRespond>;
}
