export interface CustomDetectionRulesRequest {
    name: string;
    description: string;
    severity: DetectionRuleSeverityTypes;
    expirationMode: DetectionRulesExpirationModes;
    s1ql: string;
    queryType: DetectionRulesQueryTypes;
    queryLang?: QueryLang;
    status: DetectionRuleStatuses;
    expiration?: Date | string;
    networkQuarantine: boolean;
    treatAsThreat?: TreatAsThreatTypes;
}
export interface DeleteRulesRequest {
    ids?: string[];
    creator__contains?: string;
}
export declare enum DetectionRuleSeverityTypes {
    low = "Low",
    medium = "Medium",
    high = "High",
    critical = "Critical"
}
export declare enum DetectionRulesExpirationModes {
    permanent = "Permanent",
    temporary = "Temporary"
}
export declare enum DetectionRulesQueryTypes {
    processes = "processes",
    events = "events"
}
export declare enum QueryLang {
    S1QL1 = "1.0",
    S1QL2 = "2.0"
}
export declare enum DetectionRuleStatuses {
    activating = "Activating",
    enabled = "Active",
    disabled = "Disabled"
}
export declare enum TreatAsThreatTypes {
    suspicious = "Suspicious",
    malicious = "Malicious"
}
