import { Dv2fieldsTypes } from './enums/dv2-fields-types';
import { dv2OperatorsTypes } from './enums/dv2-operators-types';
import { CustomErrorEntity } from '../../errors/custom-error-class';
import { DVComparetions } from './../deep-visibility/enums/dv-compare-arguments-types';
export declare class BaseDV2Query {
    private query;
    private queryID;
    private currentStep;
    private isFullQuery;
    constructor();
    setFullQueryPart(Entity: Dv2fieldsTypes, operator: dv2OperatorsTypes, value: any, connectorOperator?: DVComparetions.AND | DVComparetions.OR): any;
    private setQueryString;
    /**
     * Build Query
     *
     * @param {Dv2fieldsTypes} Entity
     * @param {dv2OperatorsTypes} [operators]
     * @returns
     *
     * @memberOf BaseDV2Query
     */
    setEntity(Entity: Dv2fieldsTypes, operators?: dv2OperatorsTypes): {
        query: () => CustomErrorEntity | {
            query: string;
            queryID: string;
            isFullQuery: boolean;
        };
        setOperator: any;
        operatorsAvailable: any;
        setValue?: undefined;
    } | {
        query: () => CustomErrorEntity | {
            query: string;
            queryID: string;
            isFullQuery: boolean;
        };
        setValue: any;
        setOperator?: undefined;
        operatorsAvailable?: undefined;
    };
    /**
     * Get opertors enum names
     * @returns { string[] }
     */
    getOpertorsEnumNames(): string[];
    validateOperator(Entity: Dv2fieldsTypes, operators: dv2OperatorsTypes): boolean;
    clearQuery(): void;
    getQuery(): CustomErrorEntity | {
        query: string;
        queryID: string;
        isFullQuery: boolean;
    };
}
