"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var deep_visibility_v2_1 = require("../../end-point-entitity/deep-visibility-v2");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var deep_visibility_v2_respond_states_types_1 = require("./enums/deep-visibility-v2-respond-states-types");
var custom_error_class_1 = require("../../errors/custom-error-class");
var consts_1 = require("./consts");
var base_dv_query_class_1 = require("./base-dv-query.class");
/**
 * Deep Visibility V2 - IOC
 *
 *  User Flow :
 *    1. createQuery() : queryId
 *    2. getQueryStatus(queryId): responseState ( Pulling every 2s ) /  cancelRunningQuery(queryId)
 *    3. getAllEvents()  | getEventsByType ()
 *
 *
 * @export
 * @class DeepVisibilityV2
 * @extends {EntityBaseClass}
 */
var DeepVisibilityV2 = /** @class */ (function (_super) {
    __extends(DeepVisibilityV2, _super);
    function DeepVisibilityV2(apiCall) {
        var _this = _super.call(this, deep_visibility_v2_1.DeepVisibilityV2EndPointsNames, ends_points_entitities_1.endPointsEntities.deepVisibilityV2, apiCall) || this;
        _this.apiCall = apiCall;
        _this.queryUtils = new base_dv_query_class_1.BaseDV2Query();
        return _this;
    }
    DeepVisibilityV2.prototype.get = function (queryId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.getEventTypes(queryId)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Event Types
     *
     * GET: /web/api/v2.0/dv/count-by-type
     * Retrieve Deep Visibility events types from query
     *
     * @param {string} queryId
     * @param {string[]} [siteIds]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getEventTypes = function (queryId, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2GetEventTypes, { data: { queryId: queryId, siteIds: siteIds } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Distinct Fields Data
     *
     * @param {BaseDeepVisibilityV2Request} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getDistinctFieldsData = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2GetDistinctFieldsData, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Cancel Running Query
     *
     * POST : /web/api/v2.0/dv/cancel-query
     * Stop Deep Visibility Query by queryId
     * todo: should this function be available via the SDK?
     *
     * @param {string} queryId
     * @param {string[]} [siteIds]
     * @returns
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.cancelRunningQuery = function (queryId, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var data, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        data = { queryId: queryId, siteIds: siteIds };
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2CancelRunningQuery, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get All Events
     *
     * GET: /web/api/v2.0/dv/events
     * Retrieve all Deep Visibility events from query
     *
     * @param {DeepVisibilityV2GetEventsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getAllEvents = function (data, interval) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2GetAllEvents, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Events By Type
     *
     * Retrieve Deep Visibility events from query by event type
     * GET: /web/api/v2.0/dv/events/{event_type}
     *
     * @param {dv2EventType} eventType
     * @param {DeepVisibilityV2GetEventsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getEventsByType = function (eventType, data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2GetEventsByType, __assign({ data: data }, this.prepareApiUrlQueries([eventType])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create Query
     *
     * Start Deep Visibility Query and get queryId
     * POST: /web/api/v2.0/dv/init-query
     *
     * @param {DeepVisibilityV2CreateQuery} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.createQuery = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2CreateQuery, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Count By Type
     *
     * @param {string} queryId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.countByType = function (queryId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2CountByType, { queryId: queryId })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Recent Queries
     *
     * Retrieve 8 Recent Queries Run By User
     * GET : /web/api/v2.0/dv/queries
     *
     * @param {BaseDeepVisibilityV2Request} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getRecentQueries = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2GetRecentQueries, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Query Status
     *
     * GET : /web/api/v2.0/dv/query-status
     * Retrieve Deep Visibility Query Status
     *
     * @param {string} queryId
     * @param {string[]} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getQueryStatus = function (queryId, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.dvV2GetQueryStatus, { queryId: queryId, siteIds: siteIds })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_9 = _a.sent();
                        throw err_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Available Actions
     * GET: /web/api/v2.0/dv/available-actions
     *
     * @param {BaseDeepVisibilityV2Request} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.getAvailableActions = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getAvailableActions, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_10 = _a.sent();
                        throw err_10;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Pull Query State
     *
     * @param {number} timePeriod
     * @param {any} queryID
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.pullQueryState = function (queryId, timePeriod, callBack) {
        return __awaiter(this, void 0, void 0, function () {
            var error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.setPullingInterval(queryId, timePeriod, callBack)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        error_1 = _a.sent();
                        throw error_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set Pulling Interval
     *
     * called right after createQuery function ,
     * basiclly this method gets the query status every (timePeriod) ms
     * and by defualts call getAllEvents right after FINISH status recived
     * otherwise adiitional param needed , when calling this method
     *
     * @private
     * @param {string} queryId
     * @param {number} timePeriod
     * @returns {Promise<any>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.setPullingInterval = function (queryId, timePeriod, callBack, execGetAllEvents) {
        if (execGetAllEvents === void 0) { execGetAllEvents = true; }
        return __awaiter(this, void 0, void 0, function () {
            var interval_1;
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    interval_1 = setInterval(function () { return __awaiter(_this, void 0, void 0, function () {
                        var pull, responseState, error_2;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    _a.trys.push([0, 3, , 4]);
                                    return [4 /*yield*/, this.getQueryStatus(queryId)];
                                case 1:
                                    pull = _a.sent();
                                    responseState = pull.respondData.responseState;
                                    return [4 /*yield*/, this.PullingStatus(responseState, queryId, interval_1, timePeriod, callBack)];
                                case 2: return [2 /*return*/, _a.sent()];
                                case 3:
                                    error_2 = _a.sent();
                                    throw error_2;
                                case 4: return [2 /*return*/];
                            }
                        });
                    }); }, timePeriod);
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Pulling Status
     *
     * @private
     * @param {Dv2RespondStateTypes} responseState
     * @param {string} queryId
     * @param {*} interval
     * @param {number} timePeriod
     * @returns {Promise<any>}
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.PullingStatus = function (responseState, queryId, interval, timePeriod, callBack) {
        return __awaiter(this, void 0, void 0, function () {
            var START_TIME, MAX_TIME_OUT, count, _a, passedTime, err_11;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 10, , 11]);
                        START_TIME = new Date().getTime();
                        MAX_TIME_OUT = 15000;
                        count = 1;
                        _a = responseState;
                        switch (_a) {
                            case deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.FINISHED: return [3 /*break*/, 1];
                            case deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.ERROR: return [3 /*break*/, 4];
                            case deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.EMPTY_RESULTS: return [3 /*break*/, 5];
                            case deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.EVENTS_RUNNING: return [3 /*break*/, 6];
                            case deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.PROCESS_RUNNING: return [3 /*break*/, 7];
                        }
                        return [3 /*break*/, 8];
                    case 1: return [4 /*yield*/, this.endPulling(interval, deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.FINISHED)];
                    case 2:
                        _b.sent();
                        return [4 /*yield*/, callBack(queryId)];
                    case 3: return [2 /*return*/, _b.sent()];
                    case 4: throw this.endPulling(interval, deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.ERROR);
                    case 5: return [2 /*return*/, this.endPulling(interval, deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.EMPTY_RESULTS)];
                    case 6: return [2 /*return*/, this.keepPulling(START_TIME, deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.EVENTS_RUNNING, MAX_TIME_OUT, interval)];
                    case 7: return [2 /*return*/, this.keepPulling(START_TIME, deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.PROCESS_RUNNING, MAX_TIME_OUT, interval)];
                    case 8:
                        passedTime = count++ * timePeriod;
                        return [2 /*return*/, this.keepPulling(START_TIME, consts_1.PassedTimeError(passedTime, MAX_TIME_OUT), MAX_TIME_OUT, interval)];
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        err_11 = _b.sent();
                        throw err_11;
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Keep Running
     *
     * @private
     * @param {*} startTime
     * @param {*} eventCought
     * @param {any} MAX_TIME_OUT
     * @param {any} interval
     * @returns
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.keepPulling = function (startTime, eventCought, MAX_TIME_OUT, interval) {
        var passedTime = new Date().getTime();
        var message = consts_1.TimeOutError(MAX_TIME_OUT);
        return this.isTimeOut(passedTime, startTime, MAX_TIME_OUT, interval)
            ? new custom_error_class_1.CustomErrorEntity({
                message: message
            })
            : eventCought;
    };
    /**
     * End Pulling
     *
     * @private
     * @param {*} interval
     * @param {string} resultDueTo
     * @returns
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.endPulling = function (interval, resultDueTo) {
        return __awaiter(this, void 0, void 0, function () {
            var message;
            return __generator(this, function (_a) {
                try {
                    clearInterval(interval);
                    if (resultDueTo === deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.ERROR) {
                        message = consts_1.QueryError;
                        return [2 /*return*/, new custom_error_class_1.CustomErrorEntity({ message: message })];
                    }
                    else if (resultDueTo === deep_visibility_v2_respond_states_types_1.Dv2RespondStateTypes.EMPTY_RESULTS) {
                        return [2 /*return*/, []];
                    }
                    else {
                        return [2 /*return*/, resultDueTo];
                    }
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Is Time Out
     *
     * checks if pulling reached the maximum time allowed
     * since first request was called (10s by defualt)
     *
     * @private
     * @param {any} passedTime
     * @param {any} startTime
     * @param {any} maxTime
     * @param {any} interval
     * @returns
     *
     * @memberOf DeepVisibilityV2
     */
    DeepVisibilityV2.prototype.isTimeOut = function (passedTime, startTime, maxTime, interval) {
        if (passedTime - startTime > maxTime) {
            clearInterval(interval);
            return true;
        }
        else {
            return false;
        }
    };
    return DeepVisibilityV2;
}(entity_base_class_1.EntityBaseClass));
exports.DeepVisibilityV2 = DeepVisibilityV2;
//# sourceMappingURL=deep-visibilty-v2.class.js.map