"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var dv2_fields_types_1 = require("./dv2-fields-types");
var dv2_operators_types_1 = require("./dv2-operators-types");
var fields = [
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.AgentLastOnline,
        type: 'datetime'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.FileSHA1,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.FileFullName,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.SrcPort,
        type: 'numeric'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.FileMD5,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.DNSResponse,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.FileSHA256,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ProcessStartTime,
        type: 'datetime'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.NetworkMethod,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.PID,
        type: 'numeric'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ParentProcessPID,
        type: 'numeric'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.FileCreatedAt,
        type: 'datetime'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ProcessImageSha1Hash,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.AgentName,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.SrcIP,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.DNSRequest,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ProcessImagePath,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ProcessCmd,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.AgentOS,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.AgentVersion,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.NetworkUrl,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ProcessGroupId,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.ProcessName,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.FileModifyAt,
        type: 'datetime'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.DstIP,
        type: 'string'
    },
    {
        fieldId: dv2_fields_types_1.Dv2fieldsTypes.DstPort,
        type: 'numeric'
    }
];
var operators = {
    datetime: [
        dv2_operators_types_1.dv2OperatorsTypes.BiggerThen,
        dv2_operators_types_1.dv2OperatorsTypes.BiggerOrEqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.Between,
        dv2_operators_types_1.dv2OperatorsTypes.SmallerFrom,
        dv2_operators_types_1.dv2OperatorsTypes.SmallerOREqualsTo
    ],
    numeric: [
        dv2_operators_types_1.dv2OperatorsTypes.EqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.NotEqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.BiggerThen,
        dv2_operators_types_1.dv2OperatorsTypes.BiggerOrEqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.SmallerOREqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.SmallerFrom,
        dv2_operators_types_1.dv2OperatorsTypes.Between
    ],
    string: [
        dv2_operators_types_1.dv2OperatorsTypes.EqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.NotEqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.BiggerThen,
        dv2_operators_types_1.dv2OperatorsTypes.BiggerOrEqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.SmallerOREqualsTo,
        dv2_operators_types_1.dv2OperatorsTypes.SmallerFrom,
        dv2_operators_types_1.dv2OperatorsTypes.Between
    ]
};
exports.DV2QueryFields = (function (preMappedfields, preMappedOperators) {
    var fildResults = {};
    preMappedfields.map(function (elemnt) {
        var _a;
        var type = elemnt.type;
        var fieldId = elemnt.fieldId;
        var Operators = preMappedOperators[type];
        fildResults = __assign({}, fildResults, (_a = {}, _a[fieldId] = Operators, _a.type = type, _a));
    });
    return fildResults;
})(fields, operators);
//# sourceMappingURL=dv2-entities-types.js.map