import { DVBuildQuery } from './modal/dv-build-query.interface';
import { DVComparetions } from './enums/dv-compare-arguments-types';
export declare class BaseDVQuery {
    private query;
    private queryID;
    constructor();
    /**
     * Build Query
     *
     * Private , used in addToQuery
     * the two methodes was separeted to keep functions as small as possible
     *
     * @private
     * @param {any} Entity
     * @param {any} compareAction
     * @param {any} value
     * @param {any} subEntity
     * @returns
     *
     * @memberOf DeepVisibility
     */
    private buildQuery;
    /**
     * Set Query
     *
     * this is an helper function to build queries in the sdk
     * Case the user wants to append additional subQuery additional operator (AND | OR) needed when calling this method
     * If none was provided query will be build but append
     *
     * @param {DVBuildQuery} { Entity, compareAction, value, subEntity }
     * @param {(DVComparetions.AND | DVComparetions.OR)} [operator]
     * @returns
     *
     * @memberOf DeepVisibility
     */
    setQuery({ Entity, compareAction, value, subEntity }: DVBuildQuery, oporator?: DVComparetions.AND | DVComparetions.OR): string;
    clearQuery(): void;
    getQuery(): string;
}
