"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var BaseDVQuery = /** @class */ (function () {
    function BaseDVQuery() {
    }
    /**
     * Build Query
     *
     * Private , used in addToQuery
     * the two methodes was separeted to keep functions as small as possible
     *
     * @private
     * @param {any} Entity
     * @param {any} compareAction
     * @param {any} value
     * @param {any} subEntity
     * @returns
     *
     * @memberOf DeepVisibility
     */
    BaseDVQuery.prototype.buildQuery = function (Entity, compareAction, value, subEntity) {
        var compareLeft = Entity + "." + subEntity + " ";
        var compareArgument = compareAction;
        var compareRight = " \"" + value + "\"";
        return "" + compareLeft + compareArgument + compareRight;
    };
    /**
     * Set Query
     *
     * this is an helper function to build queries in the sdk
     * Case the user wants to append additional subQuery additional operator (AND | OR) needed when calling this method
     * If none was provided query will be build but append
     *
     * @param {DVBuildQuery} { Entity, compareAction, value, subEntity }
     * @param {(DVComparetions.AND | DVComparetions.OR)} [operator]
     * @returns
     *
     * @memberOf DeepVisibility
     */
    BaseDVQuery.prototype.setQuery = function (_a, oporator) {
        var Entity = _a.Entity, compareAction = _a.compareAction, value = _a.value, subEntity = _a.subEntity;
        this.query =
            oporator && this.query
                ? this.query + " " + oporator + " " + this.buildQuery(Entity, compareAction, value, subEntity)
                : "" + this.buildQuery(Entity, compareAction, value, subEntity);
        return this.query;
    };
    BaseDVQuery.prototype.clearQuery = function () {
        this.query = '';
    };
    BaseDVQuery.prototype.getQuery = function () {
        return this.query;
    };
    return BaseDVQuery;
}());
exports.BaseDVQuery = BaseDVQuery;
//# sourceMappingURL=base-dv-query.class.js.map