"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var device_control_endpoints_1 = require("../../end-point-entitity/device-control-endpoints");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var FormData = require("form-data");
/**
 * Device Control
 * Blog post: https://www.sentinelone.com/blog/feature-spotlight-device-control/
 *
 * LTE:
 * An almost universal feature of every endpoint is the ability to plug in USBs and other peripheral devices.
 * Businesses need that flexibility, but plug-in devices introduce a vulnerability to enterprise security.
 * Whether it’s a poisoned device containing malware, or simply a route for disgruntled employees to steal and distribute company data,
 * external devices are essentially a blind spot for the enterprise.
 *
 * @export
 * @class DeviceControl
 * @extends {EntityBaseClass}
 */
var DeviceControl = /** @class */ (function (_super) {
    __extends(DeviceControl, _super);
    function DeviceControl(apiCall) {
        return _super.call(this, device_control_endpoints_1.deviceControlEndPointsNames, ends_points_entitities_1.endPointsEntities.deviceControl, apiCall) || this;
    }
    /**
     * Get
     *
     * @param {Partial<DeviceControlExtendedRequest>} [data]
     * @param {*} [filter]
     * @returns {Promise<any>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.get = function (data, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = {};
                        return [4 /*yield*/, this.getEvents(data)];
                    case 1:
                        _a.events = (_b.sent()).respondData;
                        return [4 /*yield*/, this.countByFilters(data)];
                    case 2:
                        _a.countByFilters = (_b.sent()).respondData;
                        return [4 /*yield*/, this.getInterfaces()];
                    case 3: return [2 /*return*/, (_a.interfaces = (_b.sent()).respondData,
                            _a)];
                }
            });
        });
    };
    /**
     * Get Events
     *
     * GET: /web/api/v2.0/device-control/events
     * Get a list of device control events reported by agents
     *
     * @param {DeviceControlRequest} [data]
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.getEvents = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getEvents, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_1 = _a.sent();
                        throw e_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Count By Filters
     *
     * GET: /web/api/v2.0/private/device-control/filters-count
     * Show a count of threats per filter value.
     *
     * @param {DeviceControlExtendedRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.countByFilters = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.countByFilters, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_2 = _a.sent();
                        throw e_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Interfaces
     *
     * GET : /web/api/v2.0/private/device-control/interfaces
     * Get interfaces and classes data.
     *
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.getInterfaces = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getInterfaces)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_3 = _a.sent();
                        throw e_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Unscoped Rules
     *
     * GET: /web/api/v2.0/private/device-control/unscoped
     * Get a list of device control rules, may be of mixed scopes (depending on the provided query arguments)
     *
     * @param {DeviceControlExtendedRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.getUnscopedRules = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getUnscopedRules, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_4 = _a.sent();
                        throw e_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Configuration
     *
     * GET: /web/api/v2.0/device-control/configuration
     * Get device control configuration for a given scope
     *
     * @param {Partial<BaseScope>} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.getConfiguration = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getConfiguration, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_5 = _a.sent();
                        throw e_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update Configuration
     *
     * PUT: /web/api/v2.0/device-control/configuration
     * Update device control configuration for a given scope
     *
     * @param {Partial<BaseScope>} filter
     * @param {DeviceControlUpdateConfigurationRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.updateConfiguration = function (filter, data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateConfiguration, { filter: filter, data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_6 = _a.sent();
                        throw e_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Copy Rules
     *
     * POST: /web/api/v2.0/device-control/copy-rules
     * Copies a set of rules to other scopes
     *
     * @param {DeviceControlExtendedRequest} filter
     * @param {{ siteId: string; groupIds?: string[] }} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.copyRules = function (filter, data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.copyRules, { filter: filter, data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_7 = _a.sent();
                        throw e_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Reorder Rules
     *
     * PUT:/web/api/v2.0/device-control/reorder
     * Change order of rules for a specific scope
     *
     * @param {Partial<BaseScope>} filter
     * @param {{ id: string; order: number }} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.reorderRules = function (filter, data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.reorderRules, { filter: filter, data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_8 = _a.sent();
                        throw e_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Export Rules
     *
     * GET: /web/api/v2.0/device-control/export
     * Export device control rules to CSV file
     *
     * @param {DeviceControlExtendedRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.exportRules = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.exportRules, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_9 = _a.sent();
                        throw e_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Import Rules
     *
     * POST: /web/api/v2.0/device-control/import
     * Import device control rules from a CSV file
     *
     * @param {Partial<BaseScope>} data
     * @param {object} file
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.importRules = function (data, file) {
        return __awaiter(this, void 0, void 0, function () {
            var fileData, e_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        fileData = new FormData();
                        fileData.append('file', file);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.importRules, __assign({}, data, fileData))];
                    case 1: 
                    // console.log(fileData);
                    return [2 /*return*/, _a.sent()];
                    case 2:
                        e_10 = _a.sent();
                        throw e_10;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Enable Disable Rules
     *
     * PUT:/web/api/v2.0/device-control/enable
     * Change status of a set of rules to "Enabled" or "Disabled"
     *
     * @param {DeviceControlExtendedRequest} filter
     * @param {({ status: 'Disabled' | 'Enabled' })} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.enableDisableRules = function (filter, data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.enableDisableRules, { filter: filter, data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_11 = _a.sent();
                        throw e_11;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete Rules
     *
     * DELETE: /web/api/v2.0/device-control
     * Deletes rules based on a filter
     *
     * @param {DeviceControlExtendedRequest} filter
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.deleteRules = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            var e_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deleteRules, filter)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_12 = _a.sent();
                        throw e_12;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Device Rules
     *
     * GET: /web/api/v2.0/device-control
     * Get a list of device rules for a given scope
     *
     * @param {DeviceControlExtendedRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.getDeviceRules = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_13;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getDeviceRules, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_13 = _a.sent();
                        throw e_13;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create Device Rule
     *
     * POST: /web/api/v2.0/device-control
     * Create a new device rule
     *
     * @param {Partial<BaseScope>} filter
     * @param {DeviceControlAddUpdateRuleRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.createDeviceRule = function (filter, data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_14;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.createDeviceRule, { filter: filter, data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_14 = _a.sent();
                        throw e_14;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update Device Rule
     *
     * PUT: /web/api/v2.0/device-control/{rule_id}
     * Update an existing device rule
     *
     * @param {string} ruleId
     * @param {DeviceControlAddUpdateRuleRequest} data
     * @returns {Promise<SDKRespond>}
     * @memberof DeviceControl
     */
    DeviceControl.prototype.updateDeviceRule = function (ruleId, data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_15;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateDeviceRule, __assign({}, this.prepareApiUrlQueries([ruleId]), { data: data }))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_15 = _a.sent();
                        throw e_15;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return DeviceControl;
}(entity_base_class_1.EntityBaseClass));
exports.DeviceControl = DeviceControl;
//# sourceMappingURL=device-control.class.js.map