"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var exclusions_endpoints_1 = require("../../end-point-entitity/exclusions-endpoints");
var exclustion_items_types_1 = require("./enums/exclustion-items-types");
var exclusion_types_1 = require("./enums/exclusion-types");
/**
 * Exclusions
 *
 * @export
 * @class Exclusions
 * @extends {EntityBaseClass}
 */
var Exclusions = /** @class */ (function (_super) {
    __extends(Exclusions, _super);
    function Exclusions(apiCall) {
        var _this = _super.call(this, exclusions_endpoints_1.ExclusionsEndPointsNames, ends_points_entitities_1.endPointsEntities.exlusions, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get
     * Get Black List Items + Get White List Items
     *
     * @param {ExclusionsWhiteItemGetRequest} data
     * @returns {Promise<{ whiteItems: any; blackItems: any }>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.get = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var whiteItems, blackItems, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.getWhiteItems(data)];
                    case 1:
                        whiteItems = _a.sent();
                        return [4 /*yield*/, this.getBlackItems(data)];
                    case 2:
                        blackItems = _a.sent();
                        return [2 /*return*/, { whiteItems: whiteItems, blackItems: blackItems }];
                    case 3:
                        err_1 = _a.sent();
                        throw err_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Black List Items
     *
     * List all items matching the input filter
     * GET : /web/api/v2.0/restrictions
     *
     * @param {GetListItemsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.getBlackItems = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getBlackItems, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get White List Items
     *
     * GET: /web/api/v2.0/exclusions
     * List all exclusion items matching the input filter
     *
     * @param {GetListItemsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.getWhiteItems = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getWhiteItems, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create white item
     *
     * POST: /web/api/v2.0/exclusions
     * Create exclusion item matching the input filter
     *
     * @param {CreateListItemRequest} data
     * @param {BaseScope} filter
     * @param {boolean} tenant
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.setWhiteItem = function (data, filter, tenant) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.setWhiteItem, { data: data, filter: __assign({}, filter, { tenant: tenant }) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set Black Item
     *
     * POST:/web/api/v2.0/restrictions
     * Create restriction item matching the input filter
     *
     * @param {CreateListItemRequest} data
     * @param {BaseScope} filter
     * @param {boolean} tenant
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.setBlackItem = function (data, filter, tenant) {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.setBlackItem, { data: data, filter: __assign({}, filter, { tenant: tenant }) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create
     *
     * @param {CreateListItemRequest} data
     * @param {BaseScope} filter
     * @param {boolean} tenant
     * @param {ExclusionItemsType} itemType
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.create = function (data, filter, tenant, itemType) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_6;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        if (!(itemType === exclustion_items_types_1.ExclusionItemsType.Black)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.setBlackItem(data, filter, tenant)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        _a = this.setWhiteItem(data, filter, tenant);
                        _b.label = 3;
                    case 3: return [2 /*return*/, _a];
                    case 4:
                        err_6 = _b.sent();
                        throw err_6;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update Black Item
     *
     * PUT: /web/api/v2.0/restrictions
     * Update restriction item.
     *
     * @param {ExclusionsUpdateItem} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.updateBlackItem = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateBlackItem, { data: __assign({}, data) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update White Item
     *
     * PUT: /web/api/v2.0/exclusions
     * Update exclusion item.
     *
     * @param {ExclusionsUpdateItem} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.updateWhiteItem = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateWhiteItem, { data: __assign({}, data) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update
     *
     * @param {ExclusionItemsType} itemType
     * @param {ExclusionsUpdateItem} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.update = function (itemType, data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_9;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, , 6]);
                        if (!(itemType === exclustion_items_types_1.ExclusionItemsType.Black)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.updateBlackItem(data)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.updateWhiteItem(data)];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4: return [2 /*return*/, _a];
                    case 5:
                        err_9 = _b.sent();
                        throw err_9;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete Black Item
     *
     * @param {string[]} ids
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.deleteBlackItem = function (ids) {
        return __awaiter(this, void 0, void 0, function () {
            var type;
            return __generator(this, function (_a) {
                try {
                    type = exclusion_types_1.ExclusionTypes.BlackHash;
                    return [2 /*return*/, this.makeApiCall(this.endPoints.deleteBlackItem, { data: { ids: ids, type: type } })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Delete White Item
     *
     * @private
     * @param {string[]} ids
     * @param {ExclusionTypes} type
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.deleteWhiteItem = function (ids, type) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.deleteWhiteItem, { data: { ids: ids, type: type } })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Delete
     *
     * @param {string[]} ids
     * @param {ExclusionItemsType} itemType
     * @param {ExclusionTypes} [type]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Exclusions
     */
    Exclusions.prototype.delete = function (ids, itemType, type) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_10;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, , 6]);
                        if (!(itemType === exclustion_items_types_1.ExclusionItemsType.Black)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.deleteBlackItem(ids)];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.deleteWhiteItem(ids, type)];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4: return [2 /*return*/, _a];
                    case 5:
                        err_10 = _b.sent();
                        throw err_10;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    return Exclusions;
}(entity_base_class_1.EntityBaseClass));
exports.Exclusions = Exclusions;
//# sourceMappingURL=exclusion.class.js.map