"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var filters_endpoints_1 = require("../../end-point-entitity/filters-endpoints");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
/**
 * Filters
 *
 * @export
 * @class Filters
 * @extends {EntityBaseClass}
 */
var Filters = /** @class */ (function (_super) {
    __extends(Filters, _super);
    function Filters(apiCall) {
        var _this = _super.call(this, filters_endpoints_1.FilterEndPointsNames, ends_points_entitities_1.endPointsEntities.filters, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    Filters.prototype.get = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getFilters, data)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Filters
     *
     * Get a list of saved filters
     * GET: /web/api/v2.0/filters
     *
     * @param {GetFilterRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.getFilters = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getFilters, data)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Dv Filter
     *
     * @param {GetFilterRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.getDvFilter = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getDvFilter, data)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Delete Dv Filter
     *
     * @param {string} filterId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.deleteDvFilter = function (filterId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.deleteDvFilter, this.prepareApiUrlQueries([filterId]))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Delete Filter
     *
     * @param {string} filterId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.deleteFilter = function (filterId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.deleteFilter, this.prepareApiUrlQueries([filterId]))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Save Dv Filter
     *
     * @param {CreateDvFilterRequest} data
     * @param {FilterAdditionalDataRequest} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.saveDvFilter = function (data, filter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.saveDvFilter, { data: data, filter: filter })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Save Filter
     *
     * @param {CreateFilterRequest} data
     * @param filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.saveFilter = function (data, filter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.saveFilter, { data: data, filter: filter })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Update Dv Filters
     *
     * @param {string} filterId
     * @param {UpdateDvFilterRequest} data
     * @param {string} filterName
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.updateDvFilters = function (filterId, data, filter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.updateDvFilters, __assign({ data: __assign({}, data), filter: filter }, this.prepareApiUrlQueries([filterId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Update Filter
     *
     * @param {UpdateDvFilterRequest} data
     * @param {FilterAdditionalDataRequest} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    Filters.prototype.updateFilter = function (data, filterId, filter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.updateFilter, __assign({ data: __assign({}, data, { filter: filter }) }, this.prepareApiUrlQueries([filterId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    return Filters;
}(entity_base_class_1.EntityBaseClass));
exports.Filters = Filters;
//# sourceMappingURL=filters.class.js.map