import { BaseTotalMemoryFilter } from '../../../model/base-total-memory-filter.interface';
import { BaseLastActiveDateFilter } from '../../../model/base-last-active-date-filter.interface';
import { BaseRegisteredAtFilter } from '../../../model/base-registerd-at-filter.interface';
import { AgentMachineTypes } from '../../../enums/agent-machine-types';
import { BaseCoreFilter } from '../../../model/base-core-count-filter.interface';
import { NetworkStatusesTypes } from '../../../enums/network-statuses-types';
import { ScanStatus } from '../../../enums/scan-status-type';
import { OsArchs } from '../../../enums/os-archs-types';
import { UserActionsNeeded } from '../../../enums/user-actions-needed-types';
import { OsTypes } from '../../../enums/os-types';
export interface BaseFilterFileld extends BaseTotalMemoryFilter, BaseLastActiveDateFilter, BaseRegisteredAtFilter, BaseCoreFilter {
    siteIds?: string[];
    networkStatuses?: NetworkStatusesTypes[];
    scanStatuses?: ScanStatus[];
    osArch?: OsArchs[] | OsArchs;
    query?: string;
    userActionsNeeded?: UserActionsNeeded[];
    encryptedApplications?: boolean;
    osTypes?: OsTypes[];
    infected?: boolean;
    adQuery?: string;
    groupIds?: string[];
    machineTypes?: AgentMachineTypes[];
    isPendingUninstall?: boolean;
    isActive?: boolean;
    hasLocalConfiguration?: boolean;
    agentVersions?: string[];
    domains?: string[];
    isUpToDate?: boolean;
}
