import { ScanStatus } from '../../../enums/scan-status-type';
import { UserActionsNeeded } from '../../../enums/user-actions-needed-types';
import { BaseRegisteredAtFilter } from '../../../model/base-registerd-at-filter.interface';
import { AgentMachineTypes } from '../../../enums/agent-machine-types';
import { BaseLastActiveDateFilter } from '../../../model/base-last-active-date-filter.interface';
import { BaseCoreFilter } from '../../../model/base-core-count-filter.interface';
import { OsArchs } from '../../../enums/os-archs-types';
import { BaseTotalMemoryFilter } from '../../../model/base-total-memory-filter.interface';
import { NetworkStatusesTypes } from '../../../enums/network-statuses-types';
import { OsTypes } from '../../../enums/os-types';
export interface UpdateFilterRequest extends BaseCoreFilter, BaseTotalMemoryFilter, BaseCoreFilter, BaseLastActiveDateFilter, BaseRegisteredAtFilter {
    filterFields: {
        siteIds?: string[];
        networkStatuses?: NetworkStatusesTypes[];
        scanStatuses?: ScanStatus[];
        osArch?: OsArchs;
        query?: string;
        userActionsNeeded?: UserActionsNeeded[];
        encryptedApplications?: boolean;
        osTypes?: OsTypes[];
        infected?: boolean;
        adQuery?: string;
        groupIds?: string[];
        machineTypes?: AgentMachineTypes[];
        isPendingUninstall?: boolean;
        isActive?: boolean;
        hasLocalConfiguration?: boolean;
        agentVersions?: string[];
        domains?: string[];
        isUpToDate?: boolean;
    };
}
