"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ends_points_entitities_1 = require("../../../end-point-entitity/ends-points-entitities");
var entity_base_class_1 = require("../../entity-base-class");
var forensics_endpoints_1 = require("../../../end-point-entitity/forensics-endpoints");
/**
 * Forensic Applictions
 *
 * @export
 * @class ForensicApplictions
 * @extends {EntityBaseClass}
 */
var ForensicApplictions = /** @class */ (function (_super) {
    __extends(ForensicApplictions, _super);
    function ForensicApplictions(apiCall) {
        var _this = _super.call(this, forensics_endpoints_1.ForensicsEndpointsNames, ends_points_entitities_1.endPointsEntities.forensics, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * get = getApplicationForensicDetails(applictionId) + getApplicationForensics(applictionId)
     * GET : /web/api/v2.0/applications/{application_id}/forensics
     *
     * @param {string} applictionId
     * @returns {Promise<any>}
     *
     * @memberOf ForensicApplictions
     */
    ForensicApplictions.prototype.get = function (applictionId) {
        return __awaiter(this, void 0, void 0, function () {
            var applicationForensicDetails, applicationForensics, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.getApplicationForensicDetails(applictionId)];
                    case 1:
                        applicationForensicDetails = _a.sent();
                        return [4 /*yield*/, this.getApplicationForensics(applictionId)];
                    case 2:
                        applicationForensics = _a.sent();
                        return [2 /*return*/, { applicationForensicDetails: applicationForensicDetails, applicationForensics: applicationForensics }];
                    case 3:
                        err_1 = _a.sent();
                        throw err_1;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Application Forensic Details
     * GET: /web/api/v2.0/applications/{application_id}/forensics/details
     *
     * @param {string} applicationId
     * @param {BaseScope} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ForensicApplictions
     */
    ForensicApplictions.prototype.getApplicationForensicDetails = function (applicationId, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getApplicationForensicDetails, __assign({ data: data }, this.prepareApiUrlQueries([applicationId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Application Forensics - Get forensics data for the application.
     * GET: /web/api/v2.0/applications/{application_id}/forensics
     *
     * @param {string} applicationId
     * @param {BaseScope} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ForensicApplictions
     */
    ForensicApplictions.prototype.getApplicationForensics = function (applicationId, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getApplicationForensics, __assign({ data: data }, this.prepareApiUrlQueries([applicationId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Application Connections
     * GET: /web/api/v2.0/applications/{application_id}/forensics/connections
     *
     * @param {string} applicationId
     * @param {ForensicApplictionsConnectionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ForensicApplictions
     */
    ForensicApplictions.prototype.getApplicationConnections = function (applicationId, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getApplicationConnections, __assign({ data: data }, this.prepareApiUrlQueries([applicationId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Export Application
     * GET : /web/api/v2.0/applications/{application_id}/forensics/export/{export_format}
     *
     * @param {string} applicationId
     * @param {ForensicApplictionsConnectionsRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ForensicApplictions
     */
    ForensicApplictions.prototype.exportApplication = function (applicationId, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.exportApplication, __assign({ data: data }, this.prepareApiUrlQueries([applicationId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    return ForensicApplictions;
}(entity_base_class_1.EntityBaseClass));
exports.ForensicApplictions = ForensicApplictions;
//# sourceMappingURL=forensic-applictions.class.js.map