"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var groups_endpoints_1 = require("../../end-point-entitity/groups-endpoints");
/**
 * Group Class
 *
 * @export
 * @class Group
 * @extends {EntityBaseClass}
 */
var Group = /** @class */ (function (_super) {
    __extends(Group, _super);
    function Group(apiCall) {
        var _this = _super.call(this, groups_endpoints_1.GroupsEndPointsNames, ends_points_entitities_1.endPointsEntities.groups, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get Groups
     *
     * Gets the group data.
     * GET : /web/api/v2.0/groups
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.get = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getGroups, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Groups By Id
     *
     * Gets the group data.
     * GET : /web/api/v2.0/groups/{group_id}
     *
     * @param {string} groupId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.getGroupsById = function (groupId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getGroupsById, this.prepareApiUrlQueries([groupId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Default Groups for site
     * GET: /web/api/v2.0/private/groups-default
     *
     * @param {*} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.getDefaultGroups = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getDefaultGroups, filter)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Global Policy
     *
     * GET: /web/api/v2.0/tenant/policy
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Policy
     */
    Group.prototype.getGlobalPolicy = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getGlobalPolicy)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Count Groups
     *
     * Gets count of groups per site.
     * GET : /web/api/v2.0/private/group-count
     *
     * @param {BaseScope} [scopeFilter]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.countGroups = function (scopeFilter) {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.countGroups, this.prepareApiUrlQueries([scopeFilter.groupsIds, scopeFilter.sitesIds]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Revert Groups Policy
     *
     * PUT /web/api/v2.0/groups/{group_id}/revert-policy
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.revertGroupsPolicy = function (groupId, id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.revertGroupsPolicy, __assign({ data: { id: id } }, this.prepareApiUrlQueries([groupId])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * update - updateGroups
     *
     * PUT: /web/api/v2.0/groups/{group_id}
     * Updates the group data.
     *
     * @param {string} group_id
     * @param {GroupRequestData} group
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.update = function (group_id, group) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateGroups, __assign({ data: __assign({}, group) }, this.prepareApiUrlQueries([group_id])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update Ranks
     *
     * Update groups ranks.
     * PUT: /web/api/v2.0/groups/ranks
     *
     * @param {Rank[]} ranks
     * @param {BaseScope} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.updateRanks = function (ranks, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateRanks, {
                                data: { ranks: ranks },
                                filter: { siteIds: filter.sitesIds },
                                siteIds: filter.sitesIds
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Move Agents
     *
     * @param {string} group_id
     * @param {MoveAgentGroup} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.moveAgents = function (group_id, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.moveAgents, __assign({ filter: filter }, this.prepareApiUrlQueries([group_id])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_9 = _a.sent();
                        throw err_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create
     *
     * Creates a new group.
     * POST: /web/api/v2.0/groups
     *
     * @param {GroupRequestData} group
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.create = function (group) {
        return __awaiter(this, void 0, void 0, function () {
            var err_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.createGroups, { data: group })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_10 = _a.sent();
                        throw err_10;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete Group - Deletes the group.
     * DELETE: /web/api/v2.0/groups/{group_id}
     *
     * @param {string} groupId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Group
     */
    Group.prototype.delete = function (groupId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deleteGroups, this.prepareApiUrlQueries([groupId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_11 = _a.sent();
                        throw err_11;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Group;
}(entity_base_class_1.EntityBaseClass));
exports.Group = Group;
//# sourceMappingURL=group.class.js.map