import { EntityBaseClass } from '../entity-base-class';
import { GetHashRespond } from './modal/get-hash-respond.interface';
import { ApiCall } from '../../services/api-call';
import { SDKRespond } from '../../services/modal/sdk-respond-interface';
/**
 * Hash
 *
 * @export
 * @class Hash
 * @extends {EntityBaseClass}
 */
export declare class Hash extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    get(hash: string): Promise<GetHashRespond>;
    /**
     * Get Hash Classification
     *
     * @param {string} hash
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Hash
     */
    getHashClassification(hash: string): Promise<SDKRespond>;
    /**
     * Get Hash Reputation
     *
     * @param {string} hash
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Hash
     */
    getHashReputation(hash: string): Promise<SDKRespond>;
}
