import { ApiCall } from '../../services/api-call';
import { Authenticator } from '../../services/auth.service';
import { Threats } from '../threat/threat.class';
import { Managment } from './modal/mangment.inteface';
import { Users } from '../user/users.class';
import { Activities } from '../activity/activity.class';
import { AgentActions } from '../agentAction/agent-actions.class';
import { Commands } from '../command/commamds.class';
import { Agents } from '../agent/agent';
import { Sites } from '../site/site.class';
import { System } from '../system/system.class';
import { Policy } from '../policy/policy.class';
import { Group } from '../group/group.class';
import { ConfigOverRide } from '../config-override/configOverride.class';
import { Settings } from '../settings/settings.class';
import { Update } from '../update/update.class';
import { DeepVisibility } from '../deep-visibility/deepvisibillty.class';
import { DeepVisibilityV2 } from '../deep-visibility-v2/deep-visibilty-v2.class';
import { Filters } from '../filters/filters.class';
import { Exclusions } from '../exclusion/exclusion.class';
import { Report } from '../report/report.class';
import { Hash } from '../hash/hash.class';
import { Forensic } from '../forensic/forensic.class';
import { Accounts } from '../accounts/accounts.class';
import { ApplicationsRisk } from '../applications-risk/applications-risk.class';
import { FirewallControl } from '../firewall-control/firewall-control.class';
import { DeviceControl } from '../device-control/device-control.class';
import { Tags } from '../tags/tags.class';
import { CustomDetectionRules } from '../custom-detection-rules/custom-detection-rules.class';
import { RBAC } from '../rbac/rbac.class';
import { CredGroup } from '../auto-deploy/cred-group.class';
import { CredGroupDetails } from '../auto-deploy/cred-group-details.class';
/**
 * Management
 *
 * @export
 * @class Management
 * @implements {Managment}
 */
export declare class Management implements Managment {
    private static instance;
    threats: Threats;
    accounts: Accounts;
    applicationsRisk: ApplicationsRisk;
    authenticator: Authenticator;
    activities: Activities;
    users: Users;
    agentActions: AgentActions;
    agents: Agents;
    settings: Settings;
    updates: Update;
    sites: Sites;
    system: System;
    commands: Commands;
    groups: Group;
    configOverride: ConfigOverRide;
    policy: Policy;
    deepVisibility: DeepVisibility;
    deepVisibilityV2: DeepVisibilityV2;
    filters: Filters;
    firewallControl: FirewallControl;
    tags: Tags;
    customDetectionRules: CustomDetectionRules;
    exclusions: Exclusions;
    reports: Report;
    hash: Hash;
    forensics: Forensic;
    deviceControl: DeviceControl;
    rbac: RBAC;
    credGroup: CredGroup;
    credGroupDetails: CredGroupDetails;
    /**
     * Management class is Singleton ,
     * An Instance is created , only if one was never created before
     * else we returns the previous created instance
     * That's why 'getInstance' and  'instance' are statics
     * and the constructor is private (accessible only from 'getInstance' )
     * @param host
     * @param apiPath
     */
    private constructor();
    private _apiCall;
    apiCall: ApiCall;
    /**
     * Get Instance
     * Singleton implantation
     *
     * @static
     * @param {string} host
     * @param {string} apiPath
     * @returns
     *
     * @memberOf Management
     */
    static getInstance(host: string): Management;
}
