"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var reports_endpoints_1 = require("./../../end-point-entitity/reports-endpoints");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
/**
 * Report
 *
 * @export
 * @class Report
 * @extends {EntityBaseClass}
 */
var Report = /** @class */ (function (_super) {
    __extends(Report, _super);
    function Report(apiCall) {
        var _this = _super.call(this, reports_endpoints_1.ReportsEndPointsNames, ends_points_entitities_1.endPointsEntities.reports, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get Reports
     * GET: /web/api/v2.0/reports
     *
     * @param {BaseGetReportRequest} [data]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.get = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getReports, data)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Reports Task
     *
     * @param {GetReportTaskRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.getReportsTask = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getReportsTask, data)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get insight reports
     *
     * GET: /web/api/v2.0/reports/insights/types
     * Get the list of insight reports
     *
     * @param {string[]} groupIds
     * @param {string[]} siteIds
     * @param {boolean} forceUpdate
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.getInsightType = function (groupIds, siteIds, forceUpdate) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getInsightType, {
                            data: {
                                groupIds: groupIds,
                                siteIds: siteIds,
                                forceUpdate: forceUpdate
                            }
                        })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * S1 RSS feed
     *
     * GET: /web/api/v2.0/sentinelonerss
     * Get sentinel RSS feed.
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.getRssFeed = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getRssFeed)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Delete Reports
     *
     * @param {DeleteReportsRequest} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.deleteReports = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.deleteReports, { data: {}, filter: filter })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Delete Reports Task
     *
     * @param {DeleteReportTask} filter
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.deleteReportsTask = function (filter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.deleteReportsTask, { data: {}, filter: filter })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Update Report Task
     *
     * @param {string} taskId
     * @param {UpdateReportTaskRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.updateReportTask = function (taskId, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.updateReportTask, __assign({ data: data }, this.prepareApiUrlQueries([taskId])))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Create Report Tasks
     *
     * @param {CreateReportsTaskRequest} data
     * @param {string[]} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Report
     */
    Report.prototype.createReportTasks = function (data, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.createReportTasks, { data: data, filter: { siteIds: siteIds } })];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    return Report;
}(entity_base_class_1.EntityBaseClass));
exports.Report = Report;
//# sourceMappingURL=report.class.js.map