"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../../../entity-base-class");
var settings_endpoints_1 = require("../../../../end-point-entitity/settings-endpoints");
var ends_points_entitities_1 = require("../../../../end-point-entitity/ends-points-entitities");
var custom_error_class_1 = require("../../../../errors/custom-error-class");
/**
 * Active Directory
 *
 * @export
 * @class ActiveDirectory
 * @extends {EntityBaseClass}
 */
var ActiveDirectory = /** @class */ (function (_super) {
    __extends(ActiveDirectory, _super);
    function ActiveDirectory(apiCall, system) {
        var _this = _super.call(this, settings_endpoints_1.ActiveDirectoryEndPointsNames, ends_points_entitities_1.endPointsEntities.settings, apiCall) || this;
        _this.apiCall = apiCall;
        _this.system = system;
        return _this;
    }
    /**
     * Get Active Directory Settings
     *
     * Gets the global Active Directory settings
     * GET : /web/api/v2.0/settings/active-directory
     *
     * @param {string} siteId
     * @param {boolean} tenant
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ActiveDirectory
     */
    ActiveDirectory.prototype.get = function (siteId, tenant) {
        if (tenant === void 0) { tenant = true; }
        return __awaiter(this, void 0, void 0, function () {
            var isFeatureOn, err_1, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        return [4 /*yield*/, this.getADIfFeatureOn(siteId)];
                    case 1:
                        isFeatureOn = _a.sent();
                        if (!isFeatureOn) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getADSettings, __assign({ tenant: tenant }, this.prepareApiUrlQueries([siteId])))];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        message = 'Active Directory feature is not turned on for this site ';
                        throw new custom_error_class_1.CustomErrorEntity({ message: message });
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get AD Role String
     *
     * Gets the mappings of active directory FQDNs to user roles
     * GET : settings/active-directory/scope-mapping
     *
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ActiveDirectory
     */
    ActiveDirectory.prototype.getADRoleString = function (siteId, tenant) {
        if (tenant === void 0) { tenant = true; }
        return __awaiter(this, void 0, void 0, function () {
            var isFeatureOn, err_2, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        return [4 /*yield*/, this.getADIfFeatureOn(siteId)];
                    case 1:
                        isFeatureOn = _a.sent();
                        if (!isFeatureOn) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getADRoleString, __assign({ tenant: tenant }, this.prepareApiUrlQueries([siteId])))];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        err_2 = _a.sent();
                        message = 'Active Directory feature is not turned on for this site ';
                        console.log(message);
                        throw err_2;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get AD If FeatureOn
     *
     * @private
     * @param {string} siteId
     * @returns
     *
     * @memberOf ActiveDirectory
     */
    ActiveDirectory.prototype.getADIfFeatureOn = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var enabledFeatures, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.system.getEnabledFeature([siteId])];
                    case 1:
                        enabledFeatures = _a.sent();
                        return [2 /*return*/, (enabledFeatures.respondData.hasOwnProperty('activeDirectory') &&
                                enabledFeatures.respondData.activeDirectory === true)];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set Active Directory Roles string
     *
     * Update site's active directory FQDNs
     * PUT: settings/active-directory/scope-mapping
     *
     * @param {(string[] | string)} sitesIds
     * @param {AdRolesStringsDataRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ActiveDirectory
     */
    ActiveDirectory.prototype.setADRoleString = function (siteIds, data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.setADRoleString, { data: data, filter: { siteIds: siteIds } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set AD settings
     *
     * Update global Active Directory settings
     * PUT: settings/active-directory
     *
     * Before sending the request we check for :
     *  1. that the feature toogle is turned on
     *  2. that the data gave by the user passes the tests
     *
     * @param {ActiveDirectoryRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ActiveDirectory
     */
    ActiveDirectory.prototype.setADsettings = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var testReq, message, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 6, , 7]);
                        return [4 /*yield*/, this.test(data)];
                    case 1:
                        testReq = _a.sent();
                        return [4 /*yield*/, this.getADIfFeatureOn()];
                    case 2:
                        _a.sent();
                        if (!testReq.respondData.hasOwnProperty('errors')) return [3 /*break*/, 3];
                        message = 'Active directory Test has failed...';
                        throw new custom_error_class_1.CustomErrorEntity({ message: message });
                    case 3: return [4 /*yield*/, this.makeApiCall(this.endPoints.setADsettings, data)];
                    case 4: return [2 /*return*/, _a.sent()];
                    case 5: return [3 /*break*/, 7];
                    case 6:
                        err_5 = _a.sent();
                        throw err_5;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Test AD Settings
     *
     * POST: settings/active-directory/test
     * Test active directory settings.
     * Before snding the request we check that feature toogle is turned on
     *
     * @param {ActiveDirectoryRequest} data
     * @param {BaseScope} sitesIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf ActiveDirectory
     */
    ActiveDirectory.prototype.test = function (data, sitesIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        return [4 /*yield*/, this.getADIfFeatureOn()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.testADSettings, { data: data, filter: { sitesIds: sitesIds } })];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        err_6 = _a.sent();
                        throw err_6;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return ActiveDirectory;
}(entity_base_class_1.EntityBaseClass));
exports.ActiveDirectory = ActiveDirectory;
//# sourceMappingURL=active-directory.class.js.map