import { EntityBaseClass } from '../../../entity-base-class';
import { SDKRespond } from '../../../../services/modal/sdk-respond-interface';
import { SmtpDataRequest } from './modal/smtp-data-request.interface';
import { ApiCall } from '../../../../services/api-call';
/**
 * SMTP
 *
 * @export
 * @class Smtp
 * @extends {EntityBaseClass}
 */
export declare class Smtp extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    /**
     * Get SMTP Settings
     *
     * GET: settings/smtp
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Smtp
     */
    get(siteId: string): Promise<SDKRespond>;
    /**
     * Set SMTP Settings
     *
     * PUT: settings/smtp
     * @param {SmtpDataRequest} data
     * @param {string[]} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Smtp
     */
    set(data: SmtpDataRequest, siteIds: string[]): Promise<SDKRespond>;
    /**
     * Test SMTP Settings
     *
     * POST: settings/smtp/test
     * @param {SmtpDataRequest} data
     * @param {string[]} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Smtp
     */
    test(data: SmtpDataRequest, siteIds: string[]): Promise<SDKRespond>;
}
