"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../../../entity-base-class");
var settings_endpoints_1 = require("../../../../end-point-entitity/settings-endpoints");
var ends_points_entitities_1 = require("../../../../end-point-entitity/ends-points-entitities");
var custom_error_class_1 = require("./../../../../errors/custom-error-class");
/**
 * SMTP
 *
 * @export
 * @class Smtp
 * @extends {EntityBaseClass}
 */
var Smtp = /** @class */ (function (_super) {
    __extends(Smtp, _super);
    function Smtp(apiCall) {
        var _this = _super.call(this, settings_endpoints_1.SMTPEndPointsNames, ends_points_entitities_1.endPointsEntities.settings, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get SMTP Settings
     *
     * GET: settings/smtp
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Smtp
     */
    Smtp.prototype.get = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getSMTPSettings, this.prepareApiUrlQueries([siteId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set SMTP Settings
     *
     * PUT: settings/smtp
     * @param {SmtpDataRequest} data
     * @param {string[]} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Smtp
     */
    Smtp.prototype.set = function (data, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var testReq, message, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        return [4 /*yield*/, this.test(data, siteIds)];
                    case 1:
                        testReq = _a.sent();
                        if (!(testReq && !testReq.respondData.hasOwnProperty('errors'))) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.setSMTPSettings, { data: data, filter: { siteIds: siteIds } })];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        message = 'SMTP Test Has Failed';
                        throw new custom_error_class_1.CustomErrorEntity({ message: message });
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _a.sent();
                        console.log(err_2);
                        throw err_2;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Test SMTP Settings
     *
     * POST: settings/smtp/test
     * @param {SmtpDataRequest} data
     * @param {string[]} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Smtp
     */
    Smtp.prototype.test = function (data, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.testSMTPSettings, { data: data, filter: { siteIds: siteIds } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Smtp;
}(entity_base_class_1.EntityBaseClass));
exports.Smtp = Smtp;
//# sourceMappingURL=smtp.class.js.map