import { EntityBaseClass } from '../../../entity-base-class';
import { ApiCall } from '../../../../services/api-call';
import { SDKRespond } from '../../../../services/modal/sdk-respond-interface';
import { SsoDataRequest } from './modal/sso-data-request.interface';
/**
 * SSO
 *
 * @export
 * @class SSO
 * @extends {EntityBaseClass}
 */
export declare class SSO extends EntityBaseClass {
    private apiCall;
    constructor(apiCall: ApiCall);
    /**
     * Get SSO Settings
     *
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf SSO
     */
    get(siteId: string): Promise<SDKRespond>;
    /**
     * Test SSO Settings
     * POST: settings/sso/test
     *
     * @param {SsoDataRequest} data
     * @param {BaseScope} [filter]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf SSO
     */
    test(data: SsoDataRequest, siteIds?: string[]): Promise<SDKRespond>;
    /**
     * Set SSO settings
     *
     * test request is sent to the server before
     * PUT : /settings/sso
     *
     * @param {SsoDataRequest} data
     * @param {BaseScope} [filter]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf SSO
     */
    set(data: SsoDataRequest, siteIds?: string[]): Promise<SDKRespond>;
}
