import { EntityBaseClass } from './../../../../entities/entity-base-class';
import { ApiCall } from './../../../../services/api-call';
import { SDKRespond } from './../../../../services/modal/sdk-respond-interface';
import { MicrosoftIntegration } from './modal/wdapt-base-request-interface';
import { System } from '../../../system/system.class';
export declare class WDATP extends EntityBaseClass {
    private apiCall;
    private system;
    constructor(apiCall: ApiCall, system: System);
    /**
     * Get AD If FeatureOn
     *
     * @private
     * @param {string} siteId
     * @returns
     *
     * @memberOf ActiveDirectory
     */
    private getWADTPisFeatureOn;
    /**
     * Get Microsodft Integretion settings
     *
     * @param {string} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf WDATP
     */
    get(sitesIds: string): Promise<SDKRespond>;
    /**
     * Create
     *
     * @param {MicrosoftIntegration} data
     * @param {string} siteIds
     * @returns
     *
     * @memberOf WDATP
     */
    create(data: MicrosoftIntegration, siteIds: string): Promise<SDKRespond>;
    /**
     * Update
     *
     * @param {MicrosoftIntegration} data
     * @param {string} siteIds
     * @returns
     *
     * @memberOf WDATP
     */
    update(data: MicrosoftIntegration, siteIds: string): Promise<SDKRespond>;
}
