"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("./../../../../entities/entity-base-class");
var ends_points_entitities_1 = require("./../../../../end-point-entitity/ends-points-entitities");
var settings_endpoints_1 = require("../../../../end-point-entitity/settings-endpoints");
var WDATP = /** @class */ (function (_super) {
    __extends(WDATP, _super);
    function WDATP(apiCall, system) {
        var _this = _super.call(this, settings_endpoints_1.WDAPTEndPointEndPointsNames, ends_points_entitities_1.endPointsEntities.settings, apiCall) || this;
        _this.apiCall = apiCall;
        _this.system = system;
        return _this;
    }
    /**
     * Get AD If FeatureOn
     *
     * @private
     * @param {string} siteId
     * @returns
     *
     * @memberOf ActiveDirectory
     */
    WDATP.prototype.getWADTPisFeatureOn = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var enabledFeatures, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.system.getEnabledFeature([siteId])];
                    case 1:
                        enabledFeatures = _a.sent();
                        return [2 /*return*/, (enabledFeatures.respondData.hasOwnProperty('microsoftSupported') &&
                                enabledFeatures.respondData.microsoftSupported === true)];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Microsodft Integretion settings
     *
     * @param {string} siteIds
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf WDATP
     */
    WDATP.prototype.get = function (sitesIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        return [4 /*yield*/, this.getWADTPisFeatureOn(sitesIds)];
                    case 1:
                        if (!((_a.sent()) === true)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getWdaptSettings, this.prepareApiUrlQueries([sitesIds]))];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3: return [2 /*return*/, null];
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _a.sent();
                        throw err_2;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create
     *
     * @param {MicrosoftIntegration} data
     * @param {string} siteIds
     * @returns
     *
     * @memberOf WDATP
     */
    WDATP.prototype.create = function (data, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var reqData, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        reqData = __assign({ data: __assign({}, data) }, this.prepareApiUrlQueries([siteIds]));
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.setWdaptSettings, reqData)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update
     *
     * @param {MicrosoftIntegration} data
     * @param {string} siteIds
     * @returns
     *
     * @memberOf WDATP
     */
    WDATP.prototype.update = function (data, siteIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.create(data, siteIds)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return WDATP;
}(entity_base_class_1.EntityBaseClass));
exports.WDATP = WDATP;
//# sourceMappingURL=wdatp-class.js.map