import { EntityBaseClass } from '../entity-base-class';
import { SDKRespond } from '../../services/modal/sdk-respond-interface';
import { System } from '../system/system.class';
import { ActiveDirectory } from './integretions/activeDirectory/active-directory.class';
import { Syslog } from './integretions/syslog/syslog.class';
import { Smtp } from './integretions/smtp/smtp.class';
import { SSO } from './integretions/sso/sso.class';
import { SettingGetRespond } from './modal/settings-get-respond.interface';
import { Notifications } from './notification-settings/notification-settings.class';
import { ApiCall } from '../../services/api-call';
import { WDATP } from './integretions/wdatp/wdatp-class';
/**
 * Settings
 *
 * @export
 * @class Settings
 * @extends {EntityBaseClass}
 */
export declare class Settings extends EntityBaseClass {
    private system;
    activeDirectory: ActiveDirectory;
    syslog: Syslog;
    smtp: Smtp;
    sso: SSO;
    notifications: Notifications;
    microsoft: WDATP;
    constructor(apiCall: ApiCall, system: System);
    /**
     * Get - gets all settigns of a site
     *
     * this call gets all settings (at once) , such as:
     *  - smtp
     *  - sso
     *  - syslog
     *  - Active Directory
     * -  Microsoft
     *  - notifications
     *  - system
     *  - recipients
     *  - sms
     * As such this call can take some time
     *
     * @param {string} siteId
     * @returns {Promise<SettingGetRespond>}
     *
     * @memberOf Settings
     */
    get(siteId: string): Promise<SettingGetRespond>;
    /**
     * Get System Config
     *
     * @param {string} sitesId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Settings
     */
    getSystemConfig(siteId: string): Promise<SDKRespond>;
}
