"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var settings_endpoints_1 = require("../../end-point-entitity/settings-endpoints");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var active_directory_class_1 = require("./integretions/activeDirectory/active-directory.class");
var syslog_class_1 = require("./integretions/syslog/syslog.class");
var smtp_class_1 = require("./integretions/smtp/smtp.class");
var sso_class_1 = require("./integretions/sso/sso.class");
var notification_settings_class_1 = require("./notification-settings/notification-settings.class");
var wdatp_class_1 = require("./integretions/wdatp/wdatp-class");
/**
 * Settings
 *
 * @export
 * @class Settings
 * @extends {EntityBaseClass}
 */
var Settings = /** @class */ (function (_super) {
    __extends(Settings, _super);
    function Settings(apiCall, system) {
        var _this = _super.call(this, settings_endpoints_1.SettingsEndPointsNames, ends_points_entitities_1.endPointsEntities.settings, apiCall) || this;
        _this.system = system;
        _this.activeDirectory = new active_directory_class_1.ActiveDirectory(apiCall, system);
        _this.syslog = new syslog_class_1.Syslog(apiCall);
        _this.smtp = new smtp_class_1.Smtp(apiCall);
        _this.sso = new sso_class_1.SSO(apiCall);
        _this.notifications = new notification_settings_class_1.Notifications(apiCall);
        _this.microsoft = new wdatp_class_1.WDATP(apiCall, _this.system);
        return _this;
    }
    /**
     * Get - gets all settigns of a site
     *
     * this call gets all settings (at once) , such as:
     *  - smtp
     *  - sso
     *  - syslog
     *  - Active Directory
     * -  Microsoft
     *  - notifications
     *  - system
     *  - recipients
     *  - sms
     * As such this call can take some time
     *
     * @param {string} siteId
     * @returns {Promise<SettingGetRespond>}
     *
     * @memberOf Settings
     */
    Settings.prototype.get = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var featureFlagDisabled, syslog, ad, ADRoleString, smtp, sso, notificationSettings, SMSSettings, recipientsSettings, systemConfig, microsoftConfig, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 11, , 12]);
                        featureFlagDisabled = 'Feature flag disable for this entity';
                        return [4 /*yield*/, this.syslog.get(siteId)];
                    case 1:
                        syslog = _a.sent();
                        return [4 /*yield*/, this.activeDirectory.get(siteId)];
                    case 2:
                        ad = _a.sent();
                        return [4 /*yield*/, this.activeDirectory.getADRoleString(siteId)];
                    case 3:
                        ADRoleString = _a.sent();
                        return [4 /*yield*/, this.smtp.get(siteId)];
                    case 4:
                        smtp = _a.sent();
                        return [4 /*yield*/, this.sso.get(siteId)];
                    case 5:
                        sso = _a.sent();
                        return [4 /*yield*/, this.notifications.get(siteId)];
                    case 6:
                        notificationSettings = _a.sent();
                        return [4 /*yield*/, this.notifications.getSMSettings(siteId)];
                    case 7:
                        SMSSettings = _a.sent();
                        return [4 /*yield*/, this.notifications.getRecipientsBySite({ siteIds: siteId })];
                    case 8:
                        recipientsSettings = _a.sent();
                        return [4 /*yield*/, this.getSystemConfig(siteId)];
                    case 9:
                        systemConfig = _a.sent();
                        return [4 /*yield*/, this.microsoft.get(siteId)];
                    case 10:
                        microsoftConfig = _a.sent();
                        return [2 /*return*/, {
                                integretion: {
                                    syslog: syslog.respondData,
                                    smtp: smtp.respondData,
                                    sso: sso.respondData,
                                    ad: ad
                                        ? {
                                            adSettings: ad ? ad.respondData : null,
                                            ADRoleString: ADRoleString && ADRoleString.hasOwnProperty('respondData') ? ADRoleString.respondData : null
                                        }
                                        : featureFlagDisabled,
                                    microsoft: microsoftConfig
                                        ? { microsoftSetting: microsoftConfig.hasOwnProperty('respondData') ? microsoftConfig.respondData : null }
                                        : featureFlagDisabled
                                },
                                systemConfig: systemConfig.respondData,
                                notificationSettings: notificationSettings.respondData,
                                SMSettings: SMSSettings.respondData,
                                recipientsSettings: recipientsSettings.respondData
                            }];
                    case 11:
                        err_1 = _a.sent();
                        throw err_1;
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get System Config
     *
     * @param {string} sitesId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Settings
     */
    Settings.prototype.getSystemConfig = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.getSystemConfig, this.prepareApiUrlQueries([siteId]))];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    return Settings;
}(entity_base_class_1.EntityBaseClass));
exports.Settings = Settings;
//# sourceMappingURL=settings.class.js.map