"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var sites_endpoints_1 = require("../../end-point-entitity/sites-endpoints");
/**
 * Sites
 *
 * @export
 * @class Sites
 * @extends {EntityBaseClass}
 */
var Sites = /** @class */ (function (_super) {
    __extends(Sites, _super);
    function Sites(apiCall) {
        var _this = _super.call(this, sites_endpoints_1.SitesEndPointsNames, ends_points_entitities_1.endPointsEntities.sites, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get ( all sites )
     *
     * GET : /web/api/v2.0/sites
     * List all sites with filtering options
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.get = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getSites, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get By Id
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.getById = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        console.log(siteId);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getSiteById, this.prepareApiUrlQueries([siteId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Site Policy
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     * @memberOf Sites
     */
    Sites.prototype.getSitePolicy = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getSitePolicy, this.prepareApiUrlQueries([siteId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Expire Site
     *
     * Expire site now
     * POST: /web/api/v2.0/sites/{site_id}/expire-now
     *
     * @param {any} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.expireSite = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.expireSite, this.prepareApiUrlQueries([siteId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create - creats's site
     *
     * @param {Site} site
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.create = function (site) {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.createSite, { data: site })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Regenerate Site Key
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.regenerateSiteKey = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.regenerateSiteKey, this.prepareApiUrlQueries([siteId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create With Admin
     *
     * POST  /web/api/v2.0/site-with-admin
     * @param {Site} site
     * @param {User} user
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.createWithAdmin = function (site, user) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.createWithAdmin, { data: __assign({}, site, { user: user }) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Revert Site Policy
     *
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.revertSitePolicy = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.revertSitePolicy, this.prepareApiUrlQueries([siteId]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update
     *
     * updates site
     * PUT /web/api/v2.0/sites/{site_id}te
     *
     * @param {Site} site
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.update = function (site, siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateSite, __assign({ data: __assign({ id: siteId }, site) }, this.prepareApiUrlQueries([siteId])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_9 = _a.sent();
                        throw err_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update Site Policy
     *
     * @param {string} siteId
     * @param {Policy} policy
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.updateSitePolicy = function (siteId, policy) {
        return __awaiter(this, void 0, void 0, function () {
            var err_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateSitePolicy, __assign({ data: __assign({}, policy) }, this.prepareApiUrlQueries([siteId])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_10 = _a.sent();
                        throw err_10;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Reactivate Site
     *
     * Reactivates an expired site
     * PUT : /web/api/v2.0/sites/{site_id}/reactivate
     *
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.reactivateSite = function (siteId, data) {
        return __awaiter(this, void 0, void 0, function () {
            var reqData, err_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        reqData = __assign({ data: __assign({}, data) }, this.prepareApiUrlQueries([siteId]));
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.reactivateSite, reqData)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_11 = _a.sent();
                        throw err_11;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete - delete site (by id)
     *
     * DELET : /web/api/v2.0/sites/{site_id}
     * @param {string} siteId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Sites
     */
    Sites.prototype.delete = function (siteId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deleteSite, __assign({}, this.prepareApiUrlQueries([siteId])))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_12 = _a.sent();
                        throw err_12;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Sites;
}(entity_base_class_1.EntityBaseClass));
exports.Sites = Sites;
//# sourceMappingURL=site.class.js.map