import { EntityBaseClass } from '../entity-base-class';
import { ApiCall } from '../../services/api-call';
import { BaseScope } from '../../model/scope-get.interface';
import { UpdateTagRequest } from './modal/update-tag-request.interface';
import { SDKRespond } from '../../services/modal/sdk-respond-interface';
export declare class Tags extends EntityBaseClass {
    constructor(apiCall: ApiCall);
    delete: (id?: string) => Promise<SDKRespond>;
    update: (id: string, data?: any) => Promise<SDKRespond>;
    get(data?: any): Promise<any>;
    /**
     * Create Tag
     * POST: /web/api/v2.1/tags
     * @param filter
     * @param data
     */
    create(filter?: Partial<BaseScope>, data?: UpdateTagRequest): Promise<SDKRespond>;
    /**
     * Delete Tag
     *
     * @param {string} tagId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Filters
     */
    deleteTagById(tagId: string): Promise<SDKRespond>;
}
