"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var get_error_class_1 = require("../../errors/get-error-class");
var threat_endpoints_1 = require("../../end-point-entitity/threat-endpoints");
var entity_base_class_1 = require("../entity-base-class");
/**
 * Threats
 *
 * @export
 * @class Threats
 * @extends {EntityBaseClass}
 */
var Threats = /** @class */ (function (_super) {
    __extends(Threats, _super);
    function Threats(apiCall) {
        var _this = _super.call(this, threat_endpoints_1.ThreatApiEndPointsNames, ends_points_entitities_1.endPointsEntities.threats, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get  (threats)
     *
     * get threats using a variety of filters
     * GET : /web/api/v2.0/threats
     *
     * @param {Partial<GetThreatsGrouped>} [filters]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.get = function (filters) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.threatGroups, filters)];
                    case 1: 
                    // console.log(this.endPoints.threatGroups);
                    return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Count by filters
     *
     * Show a count of threats per filter
     * Get:/web/api/v2.0/private/threats/filters-count
     *
     * @param {CountByFilterPayload} [filters]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.countByFilters = function (filters) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.makeApiCall(this.endPoints.countByFilters, filters)];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Threat Type Group
     *
     * GET: /web/api/v2.0/private/threat-groups.
     * returns extended threats data grouped by hash.
     *
     * @param {GetThreatsGrouped} [data]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.getThreatGroup = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.threatGroups, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_1 = _a.sent();
                        throw e_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Threats Summery
     *
     * GET:/web/api/v2.0/private/threats/summary
     * Get dashboard threat summary
     * groupIds[] List of Group IDs to filter by. Example: "225494730938493804,225494730938493915".
     * sitesIds[] List of Site IDs to filter by. Example: "225494730938493804,225494730938493915".
     *
     * @param {BaseScope} scope
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.getThreatsSummery = function (scope) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getThreatsSummery, scope)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Mitigate Thereat
     *
     * POST:/web/api/v2.0/threats/mitigate/{action}
     * Apply a mitigation action to a group of threats matching the input filter.
     *
     * @param {MitigateActions} action
     * @param {ThreatFilterPayload} body
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.mitigateThreat = function (action, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var requestDetails, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        requestDetails = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.mitigateThreats);
                        return [4 /*yield*/, this.apiCall.makeApiCall(requestDetails.url + "/" + action, requestDetails.method, {
                                filter: filter
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw new get_error_class_1.GetEntityError(err_3, this.entityName, this.endPoints.mitigateThreats);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Mark As Threat - Mark suspicious threats as threats.
     * Post : /web/api/v2.0/threats/mark-as-threat
     *
     * @param {MarkAsThreat} [data]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.markAsThreat = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getThreatsSummery, __assign({}, data))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Mark As Resolved
     *
     * Mark filtered threats as resolved.
     * Post: /web/api/v2.0/threats/mark-as-resolved
     *
     * @param {MarkAsResolve} body
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.markAsResolved = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.markAsResolved, body)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Mark As Benign
     *
     * Mark hashes as benign and threat as resolved.
     * Post:/web/api/v2.0/threats/mark-as-benign
     *
     * @param {MarkAsBengin} body
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.markAsBenign = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.markAsBenign, body)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Disable Engines
     *
     * POST /web/api/v2.0/threats/engines/disable
     * Disable list of engines.
     * @params body: ThreatFilterPayload
     *
     * @param {ThreatFilterPayload} body
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Threats
     */
    Threats.prototype.disableEngines = function (body) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.disableEngines, body)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Add threat hash to blacklist.
     * Post: /web/api/v2.1/threats/add-to-blacklist
     * @param blacklistPayload
     */
    Threats.prototype.addToBlackList = function (blacklistPayload, filter) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.addToBlackList, { data: blacklistPayload, filter: filter })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Add Note
     *
     * Add threat note
     * Post: /web/api/v2.0/private/threats/${threadId}/notes
     *
     * @param {string} threatId
     * @param {NotePayload} body
     * @returns {Promise<SDKRespond>}
     */
    Threats.prototype.addNote = function (note) {
        return __awaiter(this, void 0, void 0, function () {
            var err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.addNote, __assign({}, note))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_9 = _a.sent();
                        throw err_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Notes
     *
     * Get threat notes
     * Post: /web/api/v2.0/private/threats/${threadId}/notes
     *
     * @param {string} threatId
     * @returns {Promise<SDKRespond>}
     */
    Threats.prototype.getNotes = function (threadId) {
        return __awaiter(this, void 0, void 0, function () {
            var payloadQuery, err_10;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        payloadQuery = this.prepareApiUrlQueries([threadId]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getNotes, __assign({}, payloadQuery))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_10 = _a.sent();
                        throw err_10;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Edit Note
     *
     * Add threat note
     * Post: /web/api/v2.0/private/threats/${threadId}/notes
     *
     * @param {string} threatId
     * @param {NotePayload} body
     * @returns {Promise<SDKRespond>}
     */
    Threats.prototype.editNote = function (threadId, noteId, note) {
        return __awaiter(this, void 0, void 0, function () {
            var payloadQuery, err_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        payloadQuery = this.prepareApiUrlQueries([threadId, noteId]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.editNote, __assign({}, payloadQuery, note))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_11 = _a.sent();
                        throw err_11;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete Note
     *
     * Add threat note
     * Post: /web/api/v2.0/private/threats/${threadId}/notes/${noteId}
     *
     * @param {string} threatId
     * @param {NotePayload} body
     * @returns {Promise<SDKRespond>}
     */
    Threats.prototype.deleteNote = function (threadId, noteId) {
        return __awaiter(this, void 0, void 0, function () {
            var payloadQuery, err_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        payloadQuery = this.prepareApiUrlQueries([threadId, noteId]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deleteNote, __assign({}, payloadQuery))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_12 = _a.sent();
                        throw err_12;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Threats;
}(entity_base_class_1.EntityBaseClass));
exports.Threats = Threats;
//# sourceMappingURL=threat.class.js.map