"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var entity_base_class_1 = require("../entity-base-class");
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var update_endpoints_1 = require("../../end-point-entitity/update-endpoints");
var custom_error_class_1 = require("../../errors/custom-error-class");
var FormData = require("form-data");
var fs = require("fs");
/**
 * Update
 *
 * @export
 * @class Update
 * @extends {EntityBaseClass}
 */
var Update = /** @class */ (function (_super) {
    __extends(Update, _super);
    function Update(apiCall) {
        var _this = _super.call(this, update_endpoints_1.UpdatesEndPointsName, ends_points_entitities_1.endPointsEntities.updates, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * Get Latest Packages
     *
     * GET: /web/api/v2.0/update/agent/packages
     * List of all available agent packages
     *
     * @returns {Promise<SDKRespond | CustomErrorEntity>}
     *
     * @memberOf Update
     */
    Update.prototype.get = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.latestPackages)];
                    case 1: 
                    // console.log(this.endPoints.latestPackages);
                    return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        return [2 /*return*/, new custom_error_class_1.CustomErrorEntity(err_1.message)];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Upload Package
     *
     * POST : /web/api/v2.0/upload/software
     * Upload a system software package
     *
     * @param {string} filePath
     * @param {string} fileName
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    // FIXME: need to build upload file function
    Update.prototype.uploadPackage = function (filePath, fileName) {
        return __awaiter(this, void 0, void 0, function () {
            var fileContent, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        fileContent = {};
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.uploadPackage, { data: { file: fileContent } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deploy system package
     *
     * POST: upload/software/deploy
     * Deploys a system software package, should be performed only after uploading a software
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    Update.prototype.deploy = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deployPackage)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete
     *
     * Bulk delete existing packages
     * DELET: /web/api/v2.0/update/agent/packages
     *
     * @param {string[]} ids Package IDs to delete
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    Update.prototype.delete = function (ids) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deletePackages, ids)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Upload Agent Package
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    Update.prototype.uploadAgentPackage = function (data, filePath, filename) {
        return __awaiter(this, void 0, void 0, function () {
            var body_1, fileStream, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        body_1 = new FormData();
                        Object.keys(data).forEach(function (key) { return body_1.append(key, data[key]); });
                        fileStream = fs.createReadStream(filePath + filename);
                        body_1.append('file', fileStream);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.uploadAgentPackage, {
                                data: {
                                    body: body_1
                                }
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Download Package
     *
     * GET: /web/api/v2.0/update/agent/download/{site_id}/{package_id}
     * Download a package by site_id and filename
     *
     * @param {string} site_id
     * @param {string} package_id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    Update.prototype.downloadPackage = function (site_id, package_id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.downloadPackage, this.prepareApiUrlQueries([site_id, package_id]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Download Agent Package
     *
     * GET: web/api/v2.0/update/agent/download/{package_id}
     * Download a package by filename ?? (package_id?)
     *
     * @param {string} package_id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    Update.prototype.downloadAgentPackage = function (package_id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.downloadAgentPackage, this.prepareApiUrlQueries([package_id]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update
     *
     * @param {*} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Update
     */
    Update.prototype.update = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updatePackages, data)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Update;
}(entity_base_class_1.EntityBaseClass));
exports.Update = Update;
//# sourceMappingURL=update.class.js.map