"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ends_points_entitities_1 = require("../../end-point-entitity/ends-points-entitities");
var users_endpoints_1 = require("../../end-point-entitity/users-endpoints");
var entity_base_class_1 = require("../entity-base-class");
var utills_1 = require("../../utills");
var custom_error_class_1 = require("../../errors/custom-error-class");
/**
 * Users
 *
 * @export
 * @class Users
 * @extends {EntityBaseClass}
 */
var Users = /** @class */ (function (_super) {
    __extends(Users, _super);
    function Users(apiCall) {
        var _this = _super.call(this, users_endpoints_1.UsersEndPointsNames, ends_points_entitities_1.endPointsEntities.users, apiCall) || this;
        _this.apiCall = apiCall;
        return _this;
    }
    /**
     * get() = getAllUsers()
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.get = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                try {
                    return [2 /*return*/, this.getAllUsers()];
                }
                catch (err) {
                    throw err;
                }
                return [2 /*return*/];
            });
        });
    };
    /**
     * Get Logged In User
     * GET: /web/api/v2.0/private/user-info
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.getLoggedInUser = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.userInfo)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_1 = _a.sent();
                        throw err_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *
     * User Info
     *
     * Gets user info by id.
     * GET: /web/api/v2.0/private/user-info
     *
     * @param {string} [id]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.userInfo = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.userInfo, id)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw err_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Check Tenant Admin - Checks if logged in user is a tenant admin (must be logged in)
     * GET: /web/api/v2.0/users/tenant-admin-auth-check
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.checkTenantAdmin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.checkTenantAdmin)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_3 = _a.sent();
                        throw err_3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get User
     *
     * Gets a user by id.
     * GET :  /web/api/v2.0/users/{user_id}
     * @param {string} [user_id]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.getUserById = function (user_id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getUserById, this.prepareApiUrlQueries([user_id]))];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_4 = _a.sent();
                        throw err_4;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *  User By Token
     *
     *  Gets a user by token.
     *  GET: /web/api/v2.0/user
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.getUserByToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.userByToken)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_5 = _a.sent();
                        console.log(err_5);
                        throw err_5;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Request TwoFa App
     *
     * Request 2FA app
     * POST: /web/api/v2.0/users/request-app
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.requestTwoFaApp = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.requestTwoFaApp)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_1 = _a.sent();
                        throw e_1;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Generate Recovery Code
     *
     * POST: /web/api/v2.0/users/generate-recovery-codes
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.generateUserRecoveryCode = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.generateRecoveryCode)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_6 = _a.sent();
                        throw err_6;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Generate Iframe Token
     *
     * POST: /web/api/v2.0/users/generate-iframe-token
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.generateIframeToken = function (generateIframeTokenReq) {
        return __awaiter(this, void 0, void 0, function () {
            var err_7;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.generateIframeToken, { data: __assign({}, generateIframeTokenReq) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_7 = _a.sent();
                        throw err_7;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Generate Api Token
     *
     * POST: /web/api/v2.0/users/generate-api-token
     * Returns the API token for the authenticated user.
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.generateUserApiToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_8;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.generateApiToken)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_8 = _a.sent();
                        throw err_8;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Create Users
     *
     * POST: /web/api/v2.0/users
     * @param {CreateUserRequest} createUserReq
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.create = function (createUserReq) {
        return __awaiter(this, void 0, void 0, function () {
            var e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.createUsers, { data: __assign({}, createUserReq) })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        e_2 = _a.sent();
                        throw e_2;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Delete User
     *
     * Deletes an user by id.
     * Delete: /web/api/v2.0/users/{user_id}
     * @param {string} userId
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.delete = function (userId) {
        return __awaiter(this, void 0, void 0, function () {
            var err_9;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.deleteUser, userId)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_9 = _a.sent();
                        throw err_9;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Update User
     *
     * Updates a user by id.
     * If no id provided , loggedin user id will be used
     * PUT: /web/api/v2.0/users/{user_id}
     *
     * @param {string} id
     * @param {UpdateUserRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.update = function (data, id) {
        return __awaiter(this, void 0, void 0, function () {
            var userId, _a, payloadQuery, dataReq, err_10;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, , 6]);
                        if (!id) return [3 /*break*/, 1];
                        _a = id;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, this.getDefualtLoggedInUserProps(id, ['id'])];
                    case 2:
                        _a = _b.sent();
                        _b.label = 3;
                    case 3:
                        userId = _a;
                        payloadQuery = this.prepareApiUrlQueries([userId]);
                        dataReq = __assign({ data: data }, payloadQuery);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.updateUser, dataReq)];
                    case 4: return [2 /*return*/, _b.sent()];
                    case 5:
                        err_10 = _b.sent();
                        throw err_10;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Disable TwoFa
     *
     * Disables 2FA for the user
     * POST : /web/api/v2.0/users/2fa/disable
     * @param {string} id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.disableTwoFa = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_11;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.disableToFa, { data: { id: id } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_11 = _a.sent();
                        throw err_11;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Enable Two Fa
     *
     * Enables 2FA for the user
     * POST : /web/api/v2.0/users/2fa/enable
     * @param {string} id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.enableTwoFa = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_12;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.enableTwoFa, id)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_12 = _a.sent();
                        throw err_12;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Revoke Api Token
     *
     * POST : /web/api/v2.0/users/revoke-api-token
     * @param {string} id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.revokeApiToken = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_13;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.revokeApiToken, id)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_13 = _a.sent();
                        throw err_13;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Change User Password
     *
     * POST : /web/api/v2.0/users/change-password
     * @param {ChangePasswordRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.changeUserPassword = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_14;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.changePassword, { data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_14 = _a.sent();
                        throw err_14;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Sing Eula
     *
     * Mark EULA agreement signed for user scopes
     * POST : /web/api/v2.0/users/auth/eula
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.singEula = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_15;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.singInWithEula)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_15 = _a.sent();
                        throw err_15;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Verify Email
     *
     * Send verification email
     * POST : /web/api/v2.0/users/send-verification-email
     *
     * @param {string} id
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.verifyEmail = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_16;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.verifyEmail, { data: { id: id } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_16 = _a.sent();
                        throw err_16;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Verify Code
     *
     * Verify user code used for email verification.
     * POST : /web/api/v2.0/users/user-code-verification
     *
     * @param {VerifyCodeRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.verifyCode = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_17;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.verifyCode, { data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_17 = _a.sent();
                        throw err_17;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Check Viewer Auth
     *
     * Checks if logged in user has viewer permissions
     * GET : /web/api/v2.0/users/viewer-auth-check
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.checkViewerAuth = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_18;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.checkViewerAuth)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_18 = _a.sent();
                        throw err_18;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Enable Two Fa App
     *
     * Enables 2FA for the user
     * POST : /web/api/v2.0/users/2fa/enable
     *
     * @param {Enable2faAppRequest} data
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.enableTwoFaApp = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var err_19;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.enableTwoFa, { data: data })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_19 = _a.sent();
                        throw err_19;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Api Token Details
     * GET /web/api/v2.0/users/{user_id}/api-token-details
     * If no userId provided , the data returns will be of the current loggedin user
     *
     * @param {string} [user_id]
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.getApiTokenDetails = function (user_id) {
        return __awaiter(this, void 0, void 0, function () {
            var userId, _a, apiTokenRespond, message, err_20;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 5, , 6]);
                        if (!user_id) return [3 /*break*/, 1];
                        _a = user_id;
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, this.getDefualtLoggedInUserProps(user_id, ['id'])];
                    case 2:
                        _a = _b.sent();
                        _b.label = 3;
                    case 3:
                        userId = _a;
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.apiTokenDetails, this.prepareApiUrlQueries([userId]))];
                    case 4:
                        apiTokenRespond = _b.sent();
                        if (apiTokenRespond.respondData.hasOwnProperty('errors')) {
                            message = 'GetApiTokenDetails Error , user may not have ApiToken';
                            throw new custom_error_class_1.CustomErrorEntity({ message: message });
                        }
                        else {
                            return [2 /*return*/, apiTokenRespond];
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        err_20 = _b.sent();
                        throw err_20;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get All Users
     * GET /web/api/v2.0/users
     *
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Users
     */
    Users.prototype.getAllUsers = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_21;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.getUsers)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_21 = _a.sent();
                        throw err_21;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Enroll users for 2FA setup.
     *
     * POST /web/api/v2.1/users/enroll-2fa
     * @param userIds
     *
     * @returns {Promise<SDKRespond>}
     */
    Users.prototype.enroll2fa = function (userIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_22;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.enroll2fa, { data: { ids: userIds } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_22 = _a.sent();
                        throw err_22;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * trigger Reset Password On Next Login for users
     *
     * POST /web/api/v2.1/users/login/reset-password-on-next-login
     * @param userIds
     *
     * @returns {Promise<SDKRespond>}
     */
    Users.prototype.triggerResetPasswordOnNextLogin = function (userIds) {
        return __awaiter(this, void 0, void 0, function () {
            var err_23;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.makeApiCall(this.endPoints.resetPasswordOnNextLogin, { data: {}, filter: { ids: userIds } })];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_23 = _a.sent();
                        throw err_23;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Get Defualt Logged In User Props
     *
     * @private
     * @param {*} passedParams
     * @param {string[]} [requieredFields]
     * @returns
     *
     * @memberOf Users
     */
    Users.prototype.getDefualtLoggedInUserProps = function (passedParams, requieredFields) {
        return __awaiter(this, void 0, void 0, function () {
            var getLoggedInUser, extracted, err_24;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        if (!!passedParams) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getLoggedInUser()];
                    case 1:
                        getLoggedInUser = _a.sent();
                        extracted = utills_1.getRequieredFields(getLoggedInUser, requieredFields.slice());
                        return [2 /*return*/, extracted];
                    case 2: return [2 /*return*/, passedParams];
                    case 3:
                        err_24 = _a.sent();
                        throw err_24;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return Users;
}(entity_base_class_1.EntityBaseClass));
exports.Users = Users;
//# sourceMappingURL=users.class.js.map