import { SortOrder } from '../enums/sort-order-types';
import { BaseCreateFilter } from './base-creation-filter.interface';
import { BaseUpdateFilter } from './base-update-filter.interface';
import { BaseScope } from './scope-get.interface';
import { BaseRegisteredAtFilter } from './base-registerd-at-filter.interface';
/**
 * Base Get Query Params
 * contains most (if not any) query params that can be used inside the SDKRequest(interface)
 * extending interfaces are: BaseScope ,BaseCreateFilter , BaseUpdateFilter ..
 */
export interface BaseGetQueryParams extends BaseCreateFilter, BaseUpdateFilter, BaseScope, BaseRegisteredAtFilter {
    skip?: number;
    limit?: number;
    filter?: any;
    data?: any;
    sortOrder?: SortOrder;
    cursor?: string;
    query?: string;
    sortBy?: string;
    ids?: string[];
    disablePagination?: boolean;
}
