"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = require("node-fetch");
var querystring_1 = require("querystring");
var auth_method_type_1 = require("../enums/auth-method-type");
var custom_error_class_1 = require("../errors/custom-error-class");
var https = require("https");
var utills_1 = require("../utills");
var ApiCall = /** @class */ (function () {
    function ApiCall(hostName) {
        this.hostName = hostName;
        this._token = '';
        this._isAuthenticated = false;
        this._authMethod = auth_method_type_1.AuthMethodType.Token;
        this._isHttps = hostName.includes('https');
    }
    /**
     * Get Instance
     * apiCall is Singleton
     *
     * @param hostName
     * @param apiPath
     */
    ApiCall.getInstance = function (hostName) {
        if (!ApiCall.instance) {
            ApiCall.instance = new ApiCall(hostName);
        }
        return ApiCall.instance;
    };
    /**
     * Make Api Call
     *
     *  this is the most important function (exposed for the user)
     *  it summarize all action done by the SDKApiCall wrapper.
     *  1. we have agreed for a specific respond structure to be return for each call ,
     *     that is in order to get full information of both Request , Respond , and apiCall's Status
     *  2.there is Auth validation ,
     *    - if user is already logged in auth header is attached to the req
     *    - else no header is attached
     *  3. data attached to the req bu the method (Get request is attached by 'query string' etc)
     *  4. the respond from the call is attached to the requestData property (off the , same as other params
     *  5. SDKRespond is returned as a Promise
     *
     * @param urlSuffix
     * @param requestMethod
     * @param data
     */
    ApiCall.prototype.makeApiCall = function (urlSuffix, requestMethod, data) {
        return __awaiter(this, void 0, void 0, function () {
            var wrappedApi, response, jsonRes, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        return [4 /*yield*/, this.wrapApiCall(urlSuffix, requestMethod, data)];
                    case 1:
                        wrappedApi = _a.sent();
                        console.log('Loading... ' + requestMethod.toUpperCase() + '  :  ' + urlSuffix);
                        return [4 /*yield*/, node_fetch_1.default(wrappedApi.url, wrappedApi.apiRequest)];
                    case 2:
                        response = _a.sent();
                        return [4 /*yield*/, this.extractRespond(response)];
                    case 3:
                        jsonRes = _a.sent();
                        return [4 /*yield*/, this.setRespond(wrappedApi, jsonRes)];
                    case 4: 
                    // console.log(jsonRes);
                    return [2 /*return*/, _a.sent()];
                    case 5:
                        err_1 = _a.sent();
                        console.log(err_1);
                        throw new Error('HTTP Request was fail, please check host and request configurations...');
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Extract Respond
     *
     * validate that server respond is valid , before parsing it
     * @private
     * @param {any} response
     * @returns
     *
     * @memberOf ApiCall
     */
    ApiCall.prototype.extractRespond = function (response) {
        return __awaiter(this, void 0, void 0, function () {
            var message, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        return [4 /*yield*/, response];
                    case 1:
                        if (!(typeof (_a.sent()) === 'object')) return [3 /*break*/, 3];
                        return [4 /*yield*/, response.json()];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        message = 'respond Data Returned in not a valid json object';
                        throw new custom_error_class_1.CustomErrorEntity({ message: message });
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        err_2 = _a.sent();
                        throw err_2;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Set Auth Header
     * @param authData
     * @param token
     */
    ApiCall.prototype.setAuthHeader = function (authData, token) {
        var tokenValue = token ? token : '';
        var authMethod = this.extractAuthMethod(authData);
        this.setAuth(tokenValue, authMethod);
    };
    /**
     * Extract Auth Method
     * @param authData
     */
    ApiCall.prototype.extractAuthMethod = function (authData) {
        return authData && authData.hasOwnProperty('token') ? auth_method_type_1.AuthMethodType.Token : auth_method_type_1.AuthMethodType.ApiToken;
    };
    /**
     * Set Headers
     * @param _token
     * @param data
     * @param contentType
     */
    ApiCall.prototype.setHeaders = function (data, token, contentType) {
        var loginHeader = this.getIsAuthenticated() ? this.getAuthorizationHeader() : this.setAuthHeader(data, token);
        var contentTypeHeader = this.setContentTypeHeader(contentType, data);
        return __assign({}, loginHeader, contentTypeHeader);
    };
    /**
     * Wrap Api Call
     * @param endPoint
     * @param method
     * @param data
     */
    ApiCall.prototype.wrapApiCall = function (endPoint, method, data) {
        var url = this.buildUrl(endPoint, method, data);
        var wrappedApi = this.buildSDKRespond(url, method, data);
        this.addBodyRequest(method, wrappedApi, data);
        return wrappedApi;
    };
    /**
     * Build SDK Respond
     * @param url
     * @param reqMethod
     * @param data
     */
    ApiCall.prototype.buildSDKRespond = function (url, reqMethod, data) {
        var result = {
            url: url,
            respondData: {},
            apiRequest: {
                method: reqMethod,
                headers: this.setHeaders(data)
            },
            status: null
        };
        if (this._isHttps) {
            result.apiRequest['agent'] = new https.Agent({ rejectUnauthorized: false });
            return result;
        }
        return result;
    };
    /**
     * Build Url
     * @param url
     * @param method
     * @param data
     */
    ApiCall.prototype.buildUrl = function (url, method, data) {
        var questionMark = decodeURIComponent(querystring_1.stringify(data)) ? '?' : '';
        return method === "get" /* GET */ && data
            ? this.hostName + "/" + url + questionMark + decodeURIComponent(querystring_1.stringify(data))
            : this.hostName + "/" + url;
    };
    /**
     * Add Body Request
     * @param method
     * @param data
     * @param respond
     */
    ApiCall.prototype.addBodyRequest = function (method, respond, data) {
        if (method !== "get" /* GET */) {
            if (utills_1.isFormBody(data)) {
                respond.apiRequest.body = data.data.body;
            }
            else {
                var tempData = data ? __assign({}, data) : {};
                respond.apiRequest.body = JSON.stringify(tempData);
            }
        }
    };
    /**
     * Set Respond Data
     * @param wrappedApi
     * @param result : SDKRespond
     */
    ApiCall.prototype.setRespond = function (wrappedApi, result) {
        wrappedApi.respondData = result ? (result.hasOwnProperty('data') ? result.data : result) : {};
        wrappedApi.status =
            wrappedApi && wrappedApi.hasOwnProperty('respondData') && wrappedApi.respondData.hasOwnProperty('errors')
                ? wrappedApi.respondData.errors
                : 200;
        return wrappedApi;
    };
    /**
     * Get Authorization Header
     * returns {Authentication: string}
     */
    ApiCall.prototype.getAuthorizationHeader = function () {
        return { Authorization: this.getTokenMethod() + " " + this.getToken() };
    };
    /**
     * Set Is Authenticated
     * @param _isAuth :boolean
     */
    ApiCall.prototype.setIsAuthenticated = function (_isAuth) {
        this._isAuthenticated = _isAuth;
    };
    /**
     * Get Is Authenticated
     * return boolean
     */
    ApiCall.prototype.getIsAuthenticated = function () {
        return this._isAuthenticated;
    };
    /**
     * Set _token
     * @param token
     */
    ApiCall.prototype.setToken = function (token) {
        this._token = token;
    };
    /**
     * Get _token Method
     * return _authMethod
     */
    ApiCall.prototype.getTokenMethod = function () {
        return this._authMethod;
    };
    /**
     * Set Auth Method
     * @param authMethod : _authMethodType
     */
    ApiCall.prototype.setAuthMethod = function (authMethod) {
        this._authMethod = authMethod;
    };
    /**
     * Set Auth
     * @param _token
     * @param _authMethod
     */
    ApiCall.prototype.setAuth = function (_token, authMethod) {
        this.setToken(_token);
        this.setAuthMethod(authMethod);
        this.setIsAuthenticated(true);
    };
    /**
     * Set Content Type Header
     * @param contentType
     * @param data request options
     */
    ApiCall.prototype.setContentTypeHeader = function (contentType, data) {
        if (contentType === void 0) { contentType = 'application/json'; }
        if (utills_1.isFormBody(data)) {
            return {
                'content-type': "multipart/form-data; boundary=" + data.data.body.getBoundary()
            };
        }
        else {
            return { 'Content-Type': contentType };
        }
    };
    /**
     * Get _token
     * return string | null
     */
    ApiCall.prototype.getToken = function () {
        return this._token || null;
    };
    /**
     * Extract Data Respond
     * checks if the api respond has multiple values
     *  - if true :
     *    - return all res as an array
     *   else:
     *    - check if there any value at all that came back from the server
     *         True - meaning a single value has returned
     *         False - returns the respond data as is
     * @param results
     */
    ApiCall.prototype.getRespondData = function (results) {
        if (results.respondData.length > 1) {
            return results.respondData;
        }
        else if (results.respondData.length === 1) {
            return results.respondData[0];
        }
        else {
            return results.respondData;
        }
    };
    return ApiCall;
}());
exports.ApiCall = ApiCall;
//# sourceMappingURL=api-call.js.map