"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ends_points_entitities_1 = require("../end-point-entitity/ends-points-entitities");
var auth_error_1 = require("../errors/auth-error");
var get_error_class_1 = require("../errors/get-error-class");
var AuthEndPoints = require("../end-point-entitity/authenticator-endpoints");
var auth_methods_types_1 = require("../enums/auth-methods-types");
/**
 * Authenticator
 *
 * @export
 * @class Authenticator
 */
var Authenticator = /** @class */ (function () {
    function Authenticator(apiCall) {
        this.apiCall = apiCall;
        this.endPoints = AuthEndPoints.AuthenticatorEndPointNames;
        this.entityName = ends_points_entitities_1.endPointsEntities.authenticator;
        this._isAuth = false;
    }
    Object.defineProperty(Authenticator.prototype, "isAuth", {
        get: function () {
            return this._isAuth;
        },
        set: function (value) {
            this._isAuth = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Auth
     *
     * @param {AuthRequest} auth
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.authenticate = function (auth) {
        return __awaiter(this, void 0, void 0, function () {
            var authData, method, _a, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        authData = auth.data;
                        method = auth.method;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 10, , 11]);
                        if (!(this.isAuth === false)) return [3 /*break*/, 9];
                        _a = method;
                        switch (_a) {
                            case auth_methods_types_1.AuthMethodsTypes.ApiToken: return [3 /*break*/, 2];
                            case auth_methods_types_1.AuthMethodsTypes.Login: return [3 /*break*/, 4];
                            case auth_methods_types_1.AuthMethodsTypes.App: return [3 /*break*/, 5];
                            case auth_methods_types_1.AuthMethodsTypes.RecoveryCode: return [3 /*break*/, 7];
                            case auth_methods_types_1.AuthMethodsTypes.Token: return [3 /*break*/, 8];
                        }
                        return [3 /*break*/, 9];
                    case 2: return [4 /*yield*/, this.loginByApiToken(authData)];
                    case 3: return [2 /*return*/, _b.sent()];
                    case 4: return [2 /*return*/, this.loginByUserPass(authData)];
                    case 5: return [4 /*yield*/, this.authWithApp(auth.data)];
                    case 6: return [2 /*return*/, _b.sent()];
                    case 7: return [2 /*return*/, this.loginByRecoveryCode(authData)];
                    case 8: return [2 /*return*/, this.loginByToken(authData.token)];
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        err_1 = _b.sent();
                        console.log(err_1);
                        throw new auth_error_1.AuthError();
                    case 11: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * login By User Password
     *
     * @private
     * @param {*} authData
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.loginByUserPass = function (authData) {
        return __awaiter(this, void 0, void 0, function () {
            var endPointDetails, loginData, res, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        endPointDetails = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.login);
                        loginData = this.buildLoginParams(authData.username, authData.password);
                        return [4 /*yield*/, this.apiCall.makeApiCall(endPointDetails.url, endPointDetails.method, loginData.data)];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, this.postAuthentication(res)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, res];
                    case 3:
                        e_1 = _a.sent();
                        throw new auth_error_1.AuthError();
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Auth By Recovery Code
     *
     * authenticate user using a recovery code
     * POST: /web/api/v2.0/users/authenticate/recovery-code
     *
     * @private
     * @param {string} code
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.loginByRecoveryCode = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            var endPointDetails, res, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        endPointDetails = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.loginByRecoveryCode);
                        return [4 /*yield*/, this.apiCall.makeApiCall(endPointDetails.url, endPointDetails.method, {
                                data: { code: code }
                            })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, this.postAuthentication(res)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, res];
                    case 3:
                        e_2 = _a.sent();
                        throw new auth_error_1.AuthError();
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     *  Login By Token
     *
     *  Logs in by API token
     *  POST: /users/login/by-api-token
     *
     * @private
     * @param {string} token
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.loginByToken = function (token) {
        return __awaiter(this, void 0, void 0, function () {
            var req, res, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        req = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.loginByToken);
                        return [4 /*yield*/, this.apiCall.makeApiCall(req.url, req.method, { token: token })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, this.postAuthentication(res)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, res];
                    case 3:
                        e_3 = _a.sent();
                        console.log(e_3);
                        throw new get_error_class_1.GetEntityError(e_3, this.entityName, this.endPoints.loginByToken);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Login By Api Token
     * GET: /web/api/v2.0/users/login/by-token
     *
     * @private
     * @param {string} apiToken
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.loginByApiToken = function (apiToken) {
        return __awaiter(this, void 0, void 0, function () {
            var result, res, e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        result = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.loginByApiToken);
                        return [4 /*yield*/, this.apiCall.makeApiCall(result.url, result.method, { data: { apiToken: apiToken } })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, this.postAuthentication(res)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, res];
                    case 3:
                        e_4 = _a.sent();
                        console.log(e_4);
                        throw new get_error_class_1.GetEntityError(e_4, this.entityName, this.endPoints.loginByApiToken);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * authenticate with app
     *
     * POST : /web/api/v2.0/users/authenticate/app
     * @param code : string
     */
    Authenticator.prototype.authWithApp = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            var req, res, e_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        req = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.authWithApp);
                        return [4 /*yield*/, this.apiCall.makeApiCall(req.url, req.method, { code: code })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, this.postAuthentication(res)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, res];
                    case 3:
                        e_5 = _a.sent();
                        throw new get_error_class_1.GetEntityError(e_5, this.entityName, this.endPoints.authWithApp);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Build Login Params
     *
     * @param username
     * @param password
     */
    Authenticator.prototype.buildLoginParams = function (username, password) {
        return { data: { password: password, username: username, rememberMe: true } };
    };
    /**
     * Post Authentication
     *
     * @param {SDKRespond} res
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.postAuthentication = function (res) {
        return __awaiter(this, void 0, void 0, function () {
            var e_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        this.isAuth = true;
                        return [4 /*yield*/, this.apiCall.setAuthHeader(res.respondData, res.respondData.token)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        e_6 = _a.sent();
                        throw new auth_error_1.AuthError();
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Logout
     *
     * POST: /web/api/v2.0/users/logout
     * @returns {Promise<SDKRespond>}
     *
     * @memberOf Authenticator
     */
    Authenticator.prototype.logout = function () {
        return __awaiter(this, void 0, void 0, function () {
            var req, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        req = ends_points_entitities_1.getEndPoint(this.entityName, this.endPoints.logout);
                        this.isAuth = false;
                        return [4 /*yield*/, this.apiCall.makeApiCall(req.url, req.method)];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2:
                        err_2 = _a.sent();
                        throw new auth_error_1.AuthError();
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Authenticator;
}());
exports.Authenticator = Authenticator;
//# sourceMappingURL=auth.service.js.map